from DateTime import DateTime
from random import random
from calendar import monthrange

__doc__="liste des classe et fonction  utiles pour baty"

def nextPeriode(month,year):
    if month==12:
        ## on change d'annee
        month=1
        year=year+1
    else:
        month=month+1
    return Periode(month,year)
        
def prevPeriode(month,year):
    if month==1:
        ## on change d'annee
        month=12
        year=year-1
    else:
        month=month-1
    return Periode(month,year)


def sorting_by_code_num(x,y):
    i1=x[1].find('-')
    i2=y[1].find('-')
    if i1>0 and i2 >0:
    	xc=x[1][:i1]
	yc=y[1][:i2]
	try:
	  xc=int(xc)
	  yc=int(yc)
	except:
	  pass
    else:
    	xc=x[1]
	yc=y[1]
  
    return cmp(xc,yc)
    
def generate_id(prefix='',suffix=''):
    now=DateTime()
    id=prefix+now.strftime('%Y-%m-%d')+'.'+str(now.millis())[5:]+str(random())[2:4]+suffix
    return id

def addObject(self,klass,id,**kwargs):
    """ ajoute un objet au niveau de baty """
    o=klass(id)
    if(o.Schema().get('code_num')):
        code_num=self.set_code_num()
        o.update(**{'code_num':code_num})
        
    if kwargs:
        o.update(**kwargs)
    self._setObject(id, o)


    
class Periode :
    """definit la representation d'une periode selon baty"""

    def __init__(self, month, year):
        """state definit si la periode est ouverte ou non"""
        
        date=DateTime("%s/%s/01" % (year,month))
        if date.month()==month and date.year()==year:
            #good periode
            self.month=month
            self.year=year
            (firstweek,lastday)=monthrange(year,month)
            self.begin=DateTime("%s/%s/01" % (year,month))
            self.end=DateTime("%s/%s/%s" % (year,month,lastday))
            self.periode_type=(self.month % 2 == 0) and 'pair' or 'impair' 
            self.state=1
        else:
            raise "Not a good period"
    

    def isOpen(self):
        return self.state

    def close(self):
        self.state=0
        

    def get_periode_type(self):
        """ retourne si la periode est de type pair ou impair """
        return self.periode_type

    
    def __str__(self):
        return "%02d-%04d" % (self.month,self.year)


## from http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/52235
class CallbaseError(AttributeError):
    pass

def callbase(obj, base, methodname='__init__', args=(),kw=None, raiseIfMissing=None):
    try: method = getattr(base, methodname)
    except AttributeError: 
        if raiseIfMissing:
            raise CallbaseError, methodname
        return None
    return method(obj, *args,**kw)


        
