from Products.validation.interfaces import ivalidator
from Products.Archetypes.debug import log
from Products.CMFCore.utils import getToolByName
import re


class isFrenchPhoneNumber:
    __implements__ = (ivalidator,)
    def __init__(self, name):
        self.name = name
    def __call__(self, value, *args, **kwargs):
        if re.search('0\d{9}',value):
            return 1
        else:  
            return """Le numro de tlphone est incorrect"""


class isMobileFrenchPhoneNumber:
    __implements__ = (ivalidator,)
    def __init__(self, name):
        self.name = name
    def __call__(self, value, *args, **kwargs):
        if re.search('06\d{8}',value):
            return 1
        else:  
            return """Le numro de mobile est incorrect"""


class isNaf:
    __implements__ = (ivalidator,)
    def __init__(self, name):
        self.name = name
    def __call__(self, value, *args, **kwargs):
        if re.search('\d{2}\.[0-9][A-Z]',value):
            return 1
        else:  
            return """Le code Naf est incorrect, format : dd.dc"""



class isSiret:
    __implements__ = (ivalidator,)
    def __init__(self, name):
        self.name = name
    def __call__(self, value, *args, **kwargs):
        if re.search('\d{14}',value):
            return 1
        else:  
            return """Le code siret est incorrect : 14 chiffres"""

class isSiren:
    __implements__ = (ivalidator,)
    def __init__(self, name):
        self.name = name
    def __call__(self, value, *args, **kwargs):
        if re.search('\d{9}',value):
            return 1
        else:  
            return """Le code siren est incorrect : 9 chiffres"""

class isFloatandPositive:
    __implements__ = (ivalidator,)
    def __init__(self, name):
        self.name = name
    def __call__(self, value, *args, **kwargs):
        if value:
            try:
                value=float(value)
                if value > 0:
                    return 1
                else:
                    return """doit etre positif et etre un nombre decimal"""
            except:
                return """doit etre positif et etre un nombre decimal"""
        return 1

        
class validQuantite:
    __implements__ = (ivalidator,)
    def __init__(self, name):
        self.name = name
    def __call__(self, value, *args, **kwargs):
        REQUEST=kwargs.get('REQUEST')
        instance=kwargs.get('instance')
        
        
        try:
            st_apres=int(REQUEST.get('stock'))
        except:
            st_apres=0
            
        from baty_types.BatyAffaire import BatyStock
        affaire=instance.archetype_tool.getObject(REQUEST.get('affaire'))
        
        if st_apres and not isinstance(affaire,BatyStock) :
            log("ce n'est pas l'affaire stock et donc sortie de stock",affaire)
            #si c'est une sortie de stock
            uid_article=REQUEST.get('article')
            obj=instance.archetype_tool.getObject(uid_article)
            st_avant=getattr(instance,'stock',0) and int(getattr(instance,'stock',0)) or 0
            quantite_avant=float(getattr(instance,'quantite',0))
            quantite_apres=float(REQUEST.get('quantite'))
            diff=st_avant and quantite_apres-quantite_avant  or quantite_apres

            
            if obj.getStock() and float(obj.getQuantite_theorique()) >= diff:
                
                return 1
            else:
                return """Il n'y a pas assez de stock ( quantit : %s)""" % (obj.getQuantite_theorique())


class validStock:
    """ valide si la sortie de stock est possible ou pas """
    __implements__ = (ivalidator,)
    def __init__(self, name):
        self.name = name
    def __call__(self, value, *args, **kwargs):
        REQUEST=kwargs.get('REQUEST')
        instance=kwargs.get('instance')
        value=REQUEST.get('stock') and int(REQUEST.get('stock')) or 0
        
        affaire=instance.archetype_tool.getObject(REQUEST.get('affaire'))
        from baty_types.BatyAffaire import BatyStock
        log("validation set stock",str(affaire),value)
        if isinstance(affaire,BatyStock):
            """ l'affaire est de type stock , la case doitr etre forcement
            coch """
            if not value:
                return """Pas d'entree de stock possible si le stock n'est pas coch"""
            else:
                return 1
        else:
            return 1


class isUnique:
    """ valide l'unicite du code numerique """
    
    
    __implements__ = (ivalidator,)
    def __init__(self, name):
        self.name = name
    def __call__(self, value, *args, **kwargs):
        REQUEST=kwargs.get('REQUEST')
        instance=kwargs.get('instance')
        try:
            int(value)
        except:
            return """Le code doit etre numrique"""
        log('je recherche pour %s %s' % (instance.portal_type,str(value)))
        portal_catalog=getToolByName(instance,'portal_catalog')
        entreprise=instance.getEntreprise()
        brs=portal_catalog.search({'portal_type':instance.portal_type,
                                   'code_num':int(value),
                                   'path':'/'.join(entreprise.getPhysicalPath())})
        if len(brs) and brs[0].UID != instance.UID():
            return """Le code doit tre unique"""             
        
