from Products.CMFPlone.Portal import addPolicy
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.Expression import Expression
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.DirectoryView import addDirectoryViews, registerDirectory

from Products.CMFPlone.CustomizationPolicy import DefaultCustomizationPolicy

import os
from Globals import package_home


dir_export=os.path.join(package_home(globals()),'csv_import')

class BatyCustomizationPolicy(DefaultCustomizationPolicy):
    """ Customises plone for ZopeZen """

    def customize(self, portal):
        # do the base Default install, that gets
        # most of it right
        DefaultCustomizationPolicy.customize(self, portal)

        
        
        # customize slots
        # add the slots to the portal folder
        
        
        # set everything to published by default
        wf_tool=getToolByName(portal,'portal_workflow')
        plone_wf=wf_tool['plone_workflow']
        plone_wf.states.setInitialState(id='published')
        plone_wf.states['published'].setPermission('Modify portal content', 0, ('Manager', 'Owner', ))

        
        qi=portal.portal_quickinstaller
        try:
            qi.installProduct('Archetypes')
        except:
            pass
        try:
            qi.installProduct('ArchBaty')
        except:
            raise

        uf=portal.acl_users
        uf._doAddUser('BatyManager','',['Baty manager','Members'],[])
        uf._doAddUser('BatySecretaire','',['Baty secretaire','Members'],[])


class BatyFakeCustomizationPolicy(BatyCustomizationPolicy):
    """ Customises plone for ZopeZen """

    def customize(self, portal):
        BatyCustomizationPolicy.customize(self,portal)
        portal.Entreprises.invokeFactory(id='baty_sa',title='Baty Sa',description='fake baty entreprise',type_name='BatyEntreprise')
        e=portal.Entreprises.baty_sa

        ## creation des articles
        os.path.join(dir_export,'article.csv')
        e.getDestination('BatyArticle').baty_import(file(os.path.join(dir_export,'article.csv')),'BatyArticle')

        ## creation des clients
        try:
            e.getDestination('BatyClient').baty_import(file(os.path.join(dir_export,'client.csv')),'BatyClient')
        except:
            pass
        ## creation des salaries
        try:
            e.getDestination('BatySalarie').baty_import(file(os.path.join(dir_export,'salarie.csv')),'BatySalarie')
        except:
            pass

        ## creation des taches
        try:
            e.getDestination('BatyTache').baty_import(file(os.path.join(dir_export,'tache.csv')),'BatyTache')
        except:
            pass

        

        
        
        
        




        
def register(context, app_state):
    addPolicy('Baty', BatyCustomizationPolicy())
    addPolicy('FakeBaty', BatyFakeCustomizationPolicy())
