
##########################################################
##                                                      ##
## INSTALL PROCEDURE FOR Baty  TYPES                    ##
##                                                      ##
##                                                      ##
##########################################################


from Products.ArchBaty import listTypes,  PROJECTNAME, SKINS_DIRECTORY, project_globals
from Products.ArchBaty.BatyPermissions import *
from Products.ArchBaty import BatyPermissions
from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition

from Products.Archetypes.debug import log
from Products.Archetypes.Extensions.utils import installTypes, install_types,  install_actions,install_subskin
from Acquisition import aq_base
from StringIO import StringIO

from Products.CMFCore.utils import getToolByName

## security
from Products.CMFCore.CMFCorePermissions import setDefaultRoles
from Products.CMFCore import CMFCorePermissions
from AccessControl import Permissions


def install(self):
    out = StringIO()

    if not hasattr(self, "_isPortalRoot"):
        print >> out, "Must be installed in a CMF Site (read Plone)"
        return

    
     
    self.portal_properties.site_properties.manage_changeProperties(default_charset='ISO-8859-15')


    


    
    
    #installTypes(self, out, listTypes(), PROJECTNAME)

    #install_subskin(self,out, project_globals)
    
    #print >> out, "Installation Type Baty :<br/> "
    

    setup_type(self,out)
    
    #log(str(project_globals))
    ### installation baty custom validation
    setup_home(self,out)
    

    

    #### installation baty tool
    install_tools(self,out)
    setup_tool(self,out)
    setup_catalog(self,out)
    ### setup baty catalog
    #   setup_baty_catalog(self,out)
    

    
    setup_slot(self,out)
    #setup_portlet(self,out)
    setup_permission(self,out)
    setup_workflow(self,out)

    ## config for cache
    setup_cache(self,out)
    setup_action(self,out)
    setup_actionicon(self,out)
    after_install(self,out)
    return out.getvalue()
    
def setup_actionicon(self,out=StringIO()):
    
    action_icon_tool=getToolByName(self, 'portal_actionicons')
    try:
        id=action_icon_tool.getActionIcon('plone','report')
        
    except KeyError,e:
        
        action_icon_tool.addActionIcon( 
                                        'plone', 
                                        'report',
                                        'pdf_icon.gif',
                                        'Open report',
                                        0)
                                        
                              
def setup_type(self,out=StringIO()):
    installTypes(self, out, listTypes(), PROJECTNAME)
    install_subskin(self,out, project_globals)
    print >> out, "Installation Type Baty :<br/> "
    return out.getvalue()



def setup_cache(self,out=StringIO()):
    if hasattr(self,'BatyCache'):
        self.manage_delObjects('BatyCache')

    if hasattr(self,'RAMCache'):
        self.manage_delObjects('RAMCache')
    self.manage_addProduct['StandardCacheManagers'].manage_addRAMCacheManager(id='BatyCache')
    self.manage_addProduct['StandardCacheManagers'].manage_addRAMCacheManager(id='RAMCache')
    self.BatyCache.manage_editProps(title="BatyCache",
                                    settings={'request_vars':['AUTHENTICATED_USER','EntrepriseUID'],
                                              'cleanup_interval':300,
                                              'threshold':1000,
                                              'max_age':3600})
    self.RAMCache.manage_editProps(title="RAMCache",
                                    settings={'request_vars':['AUTHENTICATED_USER','ContainerUID'],
                                              'cleanup_interval':300,
                                              'threshold':1000,
                                              'max_age':3600})
    
    self.HTTPCache.manage_editProps(title='HTTPCache',
                                    settings={'interval':3600,
                                              'anonymous_only':0,
                                              'notify_urls':[]
                                              }
                                    )



def setup_member_data(self,out):
    """ custom member data for baty """
    member_data=getToolByName(self,'portal_memberdata')
    if member_data.hasProperty('baty_id_entreprise'):
        return
    else:
        member_data.manage_addProperty('baty_id_entreprise','','String')

        

def setup_home(self,out):
        ## ajout du folder Entrepreprise
    try:
        if 'Entreprises' not in self.objectIds():
            self.invokeFactory(id='Entreprises',type_name="BatyBaseEntreprise",description="Les entreprises de systeme de gestion de baty")
            
            self['Entreprises'].setDescription("Les entreprises de systeme de gestion de baty")
            try:
                
                getToolByName(self,'portal_workflow').doActionFor(self.Entreprises,'publish')
            except:
                pass

            
    except:
        raise


    ## presonalisation d'index.html
    if hasattr(self,'index_html'):
        try:
            self.index_html.setTitle('Bienvenue sur le systeme de gestion de baty')
            self.index_html.setDescription('Gestion analytique d\'entreprise par chantier')
            self.index_html.manage_editDocument("""
            Le logiciel <b>BATY</b> est un logiciel de gestion analytique destin  la petite et moyenne entreprise. C\'est une gestion labore  partir de l\'affaire ou du chantier, par opposition  une gestion globale o l\'analyse se fait sur l\'ensemble de l\'entreprise<br /><br />
            <center><img src="baty_dia.jpg" /></center>
            """,'html')
        except:
            pass
        







def install_tools(self, out):

    if not hasattr(self, "baty_tool"):
        
        addTool = self.manage_addProduct['ArchBaty'].manage_addTool
        addTool('Baty Tool')
        print >> out, "Installation Tool Baty : OK"

    #and the tool uses an index

def setup_property(self,out):
   if not hasattr(self, "baty_tool"):
       install_tools(self, out)



def setup_catalog(self,out=StringIO()):
    
    catalog = getToolByName(self, 'portal_catalog')
    base = aq_base(catalog)
    if hasattr(base, 'addIndex'):
        # Zope 2.4
        addIndex = catalog.addIndex
    else:
        # Zope 2.3 and below
        addIndex = catalog._catalog.addIndex
        
    if hasattr(base, 'addColumn'):
        # Zope 2.4
        addColumn = catalog.addColumn
    else:
        # Zope 2.3 and below
        addColumn = catalog._catalog.addColumn

    try:
        addIndex('famille_value', 'FieldIndex')

    except: pass
    try:
        addIndex('UID', 'FieldIndex')
    except:
        pass
    try:
        addIndex('stock','FieldIndex')
        
    except:
        pass
    try:
        addIndex('code_num','FieldIndex')
        
    except:
        pass
    try:
        addIndex('state_mouvement','FieldIndex')
        
    except:
        pass   

    try:
        addColumn('coefficient_value')
    except:
        pass
    try:
        addColumn('stock')
    except:
        pass
   
    
    try:
        addColumn('prix_value')
    except:
        pass
    try:
        addColumn('UID')
    except: pass
    try:
        addColumn('state_mouvement')
    except: pass
    
    try:
        addColumn('code_num')
    except: pass


def setup_baty_catalog(self,out=StringIO()):

    ## on rajoute le baty_catalog
    if hasattr(self,'baty_catalog'):
        self.manage_delObjects(['baty_catalog',])

    self.manage_addProduct['ZCatalog'].manage_addZCatalog(id='baty_catalog',title='baty_catalog')

    
    catalog = self.baty_catalog
    addIndex = catalog.addIndex
    addColumn = catalog.addColumn

    addIndex('UID', 'FieldIndex')
    addIndex('meta_type', 'FieldIndex')
    
    addIndex('getFamille', 'FieldIndex')
    
    addIndex('path','PathIndex')

    addColumn('UID' )
    addColumn('meta_type' )
    addColumn('id' )
    addColumn('getFamille' )

    addColumn('getQuantite' )
    addColumn('getPrix' )
    addColumn('getPrixAchat' )
    addColumn('getPrixBase' )
    addColumn('getPrixVente' )
    addColumn('Title' )
    addColumn('getCoefficient' )
    addColumn('getArticle' )
    addColumn('getHierName' )

    ## register baty type
    archetype_tool=getToolByName(self, 'archetype_tool')
    
    archetype_tool.setCatalogsByType( 'BatyLigneProduit',archetype_tool.getCatalogsInSite())
    archetype_tool.setCatalogsByType( 'BatyLigneProduitHeure',archetype_tool.getCatalogsInSite())
    


    
    portal_catalog=self.portal_catalog
    brs=portal_catalog.searchResults({'portal_type':['BatyLigneProduit','BatyLigneProduitHeure']},sort_on='created')
    for item in brs:
        item.getObject().reindex()



    
    ## il faut reindexe
    


def reindex_catalog(self):
    catalog=self.baty_catalog
    catalog.manage_catalogFoundItems(obj_expr="""portal_type == 'BatyLigneProduit'""")
    

def add_baty_action(self,action_id,*arg):
    baty_tool = getToolByName(self, 'baty_tool')
    list_action=[ getattr(a,'id','') for a in baty_tool.listActions()]
    if action_id not in list_action:
        
        baty_tool.addAction(action_id,*arg)
        
    
def setup_icon(self,out=StringIO()):
    actionicon=getToolByName(self,'portal_actionicons')
    try:
        actionicon.getActionIcon('plone','report')
    except:
        actionicon.manage_addActionIcon(category='plone', action_id='report', icon_expr='pdf_icon.gif', title='Open report', priority='0')
        

def setup_tool(self,out):

    ### principe du menu ####
    #root => baty
    #niveau 1 => base,saisie,etat,devis
    # pour ajouter un item a la rubrique ayant comme id <id> il  faut que la categorie soit <id_categorie de la rubrique>/<id rubrique>
    
    

    baty_tool = getToolByName(self, 'baty_tool')
    list_action=[ getattr(a,'id','') for a in baty_tool.listActions()]
    #### action niveau 1 : categorie baty
    #### action niveau 2 : categorie baty/baty_base baty/baty_saisie baty/baty_etat baty/baty_devis
    #### action niveau 3 : categorie baty/baty_base/baty_configuration



    #### niveau 1
    add_baty_action(self,'base','Base',"string:#","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty')
    add_baty_action(self,'saisie','Saisie',"string:#","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty')
    add_baty_action(self,'etat','Etat',"string:#","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty')
    add_baty_action(self,'devis','Devis',"string:#","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty')

    add_baty_action(self,'cloture','Cloture',"string:#","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty')

    #### niveau 2 - baty base javascript:openWindow('http://localhost:9080/baty_fake/Entreprises/baty_sa/base_article/createBatyObject?type_name=BatyArticle',800,600)
    add_baty_action(self,'configuration','Configuration',"python: portal.get_base_url('BatyData')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/base')
    add_baty_action(self,'article','Article',"python: portal.get_base_url('BatyBaseArticle')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/base')
    add_baty_action(self,'produit','Produit',"python: portal.get_base_url('BatyBaseProduit')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/base')
    add_baty_action(self,'taches','Taches/Primes',"python: portal.get_base_url('BatyBaseTache')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/base')
    
    add_baty_action(self,'materiel','Materiel',"python: portal.get_base_url('BatyBaseMateriel')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/base')
    add_baty_action(self,'client','Client',"python: portal.get_base_url('BatyBaseClient')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/base')
    add_baty_action(self,'base_affaire','Affaire',"python: portal.get_base_url('BatyBaseAffaire')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/base')
    add_baty_action(self,'base_journal','Journaux',"python: portal.get_base_url('BatyBaseJournal')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/base')

    

    #### niveau 3  - baty/base/configuration
    add_baty_action(self,'famille','Famille',"python: portal.get_base_url('BatyData')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/base/configuration')
    
    

    add_baty_action(self,'coefficient_frais','Coefficient frais',"python: portal.get_base_url('BatyData','coefficient')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/base/configuration')

    add_baty_action(self,'coefficient_stock','Coefficient stock',"python: portal.get_base_url('BatyData','coefficient_stock')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/base/configuration')

    add_baty_action(self,'secteur','Secteur',"python: portal.get_base_url('BatyData','secteur')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/base/configuration')


    ## niveau 2 baty/saisie
    
    

    add_baty_action(self,'creer_journal_base','Journaux',"""python: portal.get_base_url('BatyBaseJournal')""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_JOURNAL, 'baty/saisie')
    
    add_baty_action(self,'creer_journal_ana','journal analytique',"""string:${portal_url}/createBatyJournal""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_JOURNAL, 'baty/saisie/creer_journal_base')

    add_baty_action(self,'creer_journal_heure','journal des heures',"""string:${portal_url}/createBatyJournal?type=heure""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_JOURNAL, 'baty/saisie/creer_journal_base')
    
    
    add_baty_action(self,'creer_article','nouvel article',"""string: javascript:openWindow('${folder_url}/createBatyObject?type_name=BatyArticle',800,600)""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty/saisie')


    add_baty_action(self,'creer_affaire',"nouvelle affaire","""string: javascript:openWindow('${folder_url}/createBatyObject?type_name=BatyAffaire',800,600)""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty/saisie')


    add_baty_action(self,'creer_client',"nouveau client","""string: javascript:openWindow('${folder_url}/createBatyObject?type_name=BatyClient',800,600)""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty/saisie')


    add_baty_action(self,'creer_tache',"nouvelle tche","""string: javascript:openWindow('${folder_url}/createBatyObject?type_name=BatyTache',800,600)""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty/saisie')

    add_baty_action(self,'creer_prime',"nouvelle prime","""string: javascript:openWindow('${folder_url}/createBatyObject?type_name=BatyPrime',800,600)""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty/saisie')

    ### niveau 2 devis
    add_baty_action(self,'devis_list','Liste des devis',"python: portal.get_base_url('BatyBaseDevis')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/devis')
    
    ### niveau 2 devis
    add_baty_action(self,'devis_archive','Archive',"python: portal.get_base_url('BatyBaseDevis')","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/devis')

    add_baty_action(self,'devis_creation','Creation',"python: portal.get_base_url('BatyBaseDevis')+'/createObject?type_name=BatyDevis'","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/devis')

    

    ### niveau 2 cloture du mois et de l'anne
    add_baty_action(self,'cloture_mois','Cloture du mois',"python:portal.get_selected_entreprise()['url']+'/cloture_mois'","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/cloture')
    add_baty_action(self,'cloture_annee',"""Cloture de l'exercice""","python:portal.get_selected_entreprise()['url']+'cloture_exercice'","""python: member and portal.get_selected_entreprise()""",VIEW_BATY_CONTENT, 'baty/cloture')
    
    
    ## niveau 2 baty/etat
    add_baty_action(self,'etat_affaire',"Affaire",'string: #',"""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty/etat')

    add_baty_action(self,'etat_compte',"Compte exploitation mensuels",'string: #',"""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty/etat')

    add_baty_action(self,'etat_clorure',"Clorures affaires",'string: #',"""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty/etat')


    add_baty_action(self,'etat_travaux',"Travaux en cours",'string: #',"""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty/etat')

    add_baty_action(self,'etat_stocks',"Etat des stocks","""python:str(portal.get_base_url('BatyBaseAffaire'))+'/batystock_custom_view'""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty/etat')

    add_baty_action(self,'etat_mouvement',"Mouvement en cours","""python:str(portal.get_base_url('BatyBaseAffaire'))+'/batymouvement_custom_view'""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty/etat')

    ## entreprise
    
    
    add_baty_action(self,'list_entreprise',"Entreprises","""string:${portal_url}/Entreprises""","""python: member""",ADD_BATY_CONTENT,'portal_tabs')

    
    add_baty_action(self,'modif_devis',"Update","""string:baty_modify_devis:method""","""python: object.portal_type == 'BatyProduit'""",ADD_BATY_CONTENT,'baty_folder_buttons')


   


    
    ### setup action
    
#     if 'journal' not in list_action:
#         baty_tool.addAction('journal','Crer un nouveau journal',"""python: object.base_journal.absolute_url()+'/createObject?type_name=BatyJournal'""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_JOURNAL, 'baty')

#     if 'article' not in list_action:
#         baty_tool.addAction('article','Crer un nouvel article',"""python: object.base_article.absolute_url()+'/createObject?type_name=BatyArticle'""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty')

#     if 'affaire' not in list_action:
#         baty_tool.addAction('affaire',"Crer une nouvelle affaire","""python: object.base_affaire.absolute_url()+'/createObject?type_name=BatyAffaire'""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty')

#     if 'client' not in list_action:
#         baty_tool.addAction('client',"Crer un nouveau client","""python: object.base_client.absolute_url()+'/createObject?type_name=BatyClient'""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty')

#     if 'tache' not in list_action:
#         baty_tool.addAction('tache',"Crer une nouvelle tche","""python: object.base_tache.absolute_url()+'/createObject?type_name=BatyTache'""","""python: member and portal.get_selected_entreprise()""",ADD_BATY_CONTENT,'baty')
    
    
#     if 'stock' not in list_action:
#         baty_tool.addAction('stock','Voir le stock',"python: object.base_affaire.aff_stock.absolute_url()+'/batystock_custom_view'","""python: member and portal.get_selected_entreprise()""",EDIT_BATY_CONTENT,'baty')

#     if 'mouvement'  not in list_action:
#         baty_tool.addAction('mouvement','Mouvement',"string: ${object_url}/baty_mouvement_view","""python: member and portal.get_selected_entreprise()""",EDIT_BATY_CONTENT,'baty')

    if 'delete' not in list_action:
        baty_tool.addAction('delete','Delete',"string:baty_folder_delete:method","",Permissions.delete_objects,'baty_folder_buttons')
        
    
    portal_action = getToolByName(self, 'portal_actions')
    m_actions=portal_action.listActions()
    for a in m_actions:
        if getattr(a,'id','') in ('change_status',):
            a.visible=0
    portal_action._actions=m_actions
    
    
    portal_action.addActionProvider('baty_tool')



def setup_action(self,out=StringIO()):
    """ setup baty form controler baty action """
    portal_form_controller= getToolByName(self, 'portal_form_controller')
    portal_form_controller.addFormAction('content_edit',
                                        'success',
                                        'BatyArticle',
                                        '',
                                        'redirect_to',
                                        'string:folder_contents')
    print >> out,'setup action','content_edit'

def after_install(self,out=StringIO()):
    """ reindex le catalogue """
    baty_tool = getToolByName(self, 'baty_tool')
    baty_tool.reindex_baty_article()

    type_tool = getToolByName(self,'portal_types')
    ti=type_tool.getTypeInfo('BatyData')
    _actions = ti._actions
    for action in _actions:
        
        if getattr(action,'id','') in ('view',):
            
            setattr(action,'title','Famille')
            
            
            
        
        
        
    



def setup_workflow(self,out=StringIO()):
    """ mis a jour du workflow """
    workflow_tool = getToolByName(self, 'portal_workflow')
    if 'baty_mouvement' in workflow_tool.objectIds():
        ## on le supprime
        workflow_tool.manage_delObjects( ['baty_mouvement',])
    
    
#     import os
#     import shutil
#     from App.config import getConfiguration
#     from Globals import package_home
    
#     cfg = getConfiguration()
#     homedir=package_home(project_globals)
#     import_dir=os.path.join(homedir, 'import')
    
#     os.chdir(import_dir)

#     for file in os.listdir('.'):
#         dst=os.path.join(cfg.instancehome,'import',file)
#         shutil.copyfile(file, dst)
#         workflow_tool.manage_importObject(file)


    wf=DCWorkflowDefinition('baty_mouvement')
    ## voir Products/DCWorkflow/Defaults
    ## permission gerer par le workflow
    workflow_tool._setObject('baty_mouvement',wf)
    wf=workflow_tool.baty_mouvement
    wf.permissions+=(BatyPermissions.EDIT_BATY_JOURNAL,BatyPermissions.VIEW_BATY_JOURNAL,BatyPermissions.ADD_BATY_CONTENT,CMFCorePermissions.ModifyPortalContent,CMFCorePermissions.AddPortalContent,'Delete objects','Copy or Move')

    ## definition des etats
    for s in ('creation','cloture'):
        wf.states.addState(s)
    ## definition des transitions
    for t in ('mouvementer',):
        wf.transitions.addTransition(t)
    for v in ('time','actor','action','review_history','comments'):
        wf.variables.addVariable(v)
    ## definition de l'etat initial
    wf.states.setInitialState('creation')

    ## setup des etats
    

    ## ajout du script mouvementer
    wf.scripts.manage_addProduct['PythonScripts'].manage_addPythonScript('mouvementer')
    wf.scripts.mouvementer.ZPythonScript_edit('state_change','context.baty_tool.cloture_journal(state_change.object)')


    sdef = wf.states['creation']
    sdef.setProperties(
        title='En Creation',
        transitions=('mouvementer',))
    sdef.setPermission('Copy or Move', 0, ('Manager'))
    sdef.setPermission(BatyPermissions.VIEW_BATY_JOURNAL, 1, ('Manager','Owner','Baty manager','Baty secretaire' ))
    sdef.setPermission(BatyPermissions.EDIT_BATY_JOURNAL, 1, ('Manager','Owner','Baty manager','Baty secretaire' ))
    sdef.setPermission(BatyPermissions.EDIT_BATY_JOURNAL, 1, ('Manager','Owner','Baty manager','Baty secretaire' ))
    sdef.setPermission('Delete Objects', 1, ('Manager','Owner','Baty manager','Baty secretaire' ))
    sdef.setPermission('Copy or Move',0,('Manager',))

    sdef = wf.states['cloture']
    sdef.setProperties(
        title='Cloture',
        
        )
    
    sdef.setPermission(BatyPermissions.VIEW_BATY_JOURNAL, 1, ('Manager','Owner','Baty manager','Baty secretaire' ))
    sdef.setPermission(BatyPermissions.EDIT_BATY_JOURNAL, 0, ('Manager',))
    sdef.setPermission(BatyPermissions.ADD_BATY_CONTENT,0, ('Manager',))
    sdef.setPermission('Delete objects', 0, ('Manager',))
    sdef.setPermission('Copy or Move',0,('Manager',))
    sdef.setPermission(CMFCorePermissions.ModifyPortalContent,0,('Manager',))
    sdef.setPermission(CMFCorePermissions.AddPortalContent ,0,('Manager',))
    
    ### definition des transitions

    tdef = wf.transitions['mouvementer']
    tdef.setProperties(
        title='Mouvementer',
        new_state_id='cloture',
        actbox_name='Cloturer',
        script_name='mouvementer',
        actbox_url='%(content_url)s/baty_mouvement_status_modify?workflow_action=mouvementer',
        actbox_category='baty_workflow',
        props={'guard_permissions':BatyPermissions.BATY_MOUVEMENT})

    
    ### definition des variables

    ## variable de workflow
    wf.variables.setStateVar('state_mouvement')
    
    vdef = wf.variables['action']
    vdef.setProperties(description='The last transition',
                       default_expr='transition/getId|nothing',
                       for_status=1, update_always=1)

    vdef = wf.variables['actor']
    vdef.setProperties(description='The ID of the user who performed '
                       'the last transition',
                       default_expr='user/getId',
                       for_status=1, update_always=1)

    vdef = wf.variables['review_history']
    vdef.setProperties(description='Provides access to workflow history',
                       default_expr="state_change/getHistory",
                       props={'guard_permissions':
                              BatyPermissions.BATY_MOUVEMENT + ';' })

    vdef = wf.variables['time']
    vdef.setProperties(description='Time of the last transition',
                       default_expr="state_change/getDateTime",
                       for_status=1, update_always=1)

    vdef = wf.variables['comments']
    vdef.setProperties(description='comment about the last transition',
                       default_expr="python:state_change.kwargs.get('comment', '')",
                       for_status=1, update_always=1)

    
    print >> out," Installation workflow",  wf        
    setup_workflow_heure(self,out)
    setup_workflow_devis(self,out)
    workflow_tool.setChainForPortalTypes(['BatyJournal','BatyJournalLigne'],('baty_mouvement',))
    workflow_tool.setChainForPortalTypes(['BatyJournalHeure','BatyJournalHeureLigne'],('baty_heure',))
    workflow_tool.setChainForPortalTypes(['BatyDevis',],('baty_devis',))
    
    workflow_tool.setChainForPortalTypes(['BatyBaseAffaire','BatyBaseJournal','BatyBaseArticle','BatyBaseEntreprise','BatyBaseMateriel','BatyBaseProduit','BatyBaseSalarie','BatyBaseSecteur'],('folder_workflow',))
    workflow_tool.updateRoleMappings()
    return out.getvalue()
    
    
    
def setup_workflow_heure(self,out):
    """ mis a jour du workflow """
    workflow_tool = getToolByName(self, 'portal_workflow')
    if 'baty_heure' in workflow_tool.objectIds():
        ## on le supprime
        workflow_tool.manage_delObjects( ['baty_heure',])
    
     

    wf=DCWorkflowDefinition('baty_heure')
    ## voir Products/DCWorkflow/Defaults
    ## permission gerer par le workflow
    workflow_tool._setObject('baty_heure',wf)
    wf=workflow_tool.baty_heure
    wf.permissions+=(BatyPermissions.EDIT_BATY_JOURNAL,BatyPermissions.VIEW_BATY_JOURNAL,BatyPermissions.ADD_BATY_CONTENT,CMFCorePermissions.ModifyPortalContent,CMFCorePermissions.AddPortalContent,'Delete objects','Copy or Move')

    ## definition des etats
    for s in ('creation','cloture'):
        wf.states.addState(s)
    ## definition des transitions
    for t in ('mouvementer',):
        wf.transitions.addTransition(t)
    for v in ('time','actor','action','review_history','comments'):
        wf.variables.addVariable(v)
    ## definition de l'etat initial
    wf.states.setInitialState('creation')

    ## setup des etats
    

  

    sdef = wf.states['creation']
    sdef.setProperties(
        title='En Creation',
        transitions=('mouvementer',))
    sdef.setPermission('Copy or Move', 0, ('Manager'))
    sdef.setPermission(BatyPermissions.VIEW_BATY_JOURNAL, 1, ('Manager','Owner','Baty manager','Baty secretaire' ))
    sdef.setPermission(BatyPermissions.EDIT_BATY_JOURNAL, 1, ('Manager','Owner','Baty manager','Baty secretaire' ))
    sdef.setPermission(BatyPermissions.EDIT_BATY_JOURNAL, 1, ('Manager','Owner','Baty manager','Baty secretaire' ))
    sdef.setPermission('Delete Objects', 1, ('Manager','Owner','Baty manager','Baty secretaire' ))
    sdef.setPermission('Copy or Move',0,('Manager',))


    
    

    sdef = wf.states['cloture']
    sdef.setProperties(
        title='Cloture',
        
        )
    
    sdef.setPermission(BatyPermissions.VIEW_BATY_JOURNAL, 1, ('Manager','Owner','Baty manager','Baty secretaire' ))
    sdef.setPermission(BatyPermissions.EDIT_BATY_JOURNAL, 0, ('Manager',))
    sdef.setPermission(BatyPermissions.ADD_BATY_CONTENT,0, ('Manager',))
    sdef.setPermission('Delete objects', 0, ('Manager',))
    sdef.setPermission('Copy or Move',0,('Manager',))
    sdef.setPermission(CMFCorePermissions.ModifyPortalContent,0,('Manager',))
    sdef.setPermission(CMFCorePermissions.AddPortalContent ,0,('Manager',))
    
    ### definition des transitions

    tdef = wf.transitions['mouvementer']
    tdef.setProperties(
        title='Mouvementer',
        new_state_id='cloture',
        actbox_name='Cloturer',
        
        actbox_url='%(content_url)s/baty_mouvement_heure',
        actbox_category='baty_workflow',
        props={'guard_permissions':BatyPermissions.BATY_MOUVEMENT})


    
    
    ### definition des variables

    ## variable de workflow
    wf.variables.setStateVar('state_mouvement')
    
    vdef = wf.variables['action']
    vdef.setProperties(description='The last transition',
                       default_expr='transition/getId|nothing',
                       for_status=1, update_always=1)

    vdef = wf.variables['actor']
    vdef.setProperties(description='The ID of the user who performed '
                       'the last transition',
                       default_expr='user/getId',
                       for_status=1, update_always=1)

    vdef = wf.variables['review_history']
    vdef.setProperties(description='Provides access to workflow history',
                       default_expr="state_change/getHistory",
                       props={'guard_permissions':
                              BatyPermissions.BATY_MOUVEMENT + ';' })

    vdef = wf.variables['time']
    vdef.setProperties(description='Time of the last transition',
                       default_expr="state_change/getDateTime",
                       for_status=1, update_always=1)

    
    vdef = wf.variables['comments']
    vdef.setProperties(description='comment about the last transition',
                       default_expr="python:state_change.kwargs.get('comment', '')",
                       for_status=1, update_always=1)

    
    print >> out," Installation workflow",  wf        
    

   
        

def setup_slot(self,out):
    """ configure les slots """
    ## attention pas d'espace au niveau des identifiants

    left_slots=(
        'here/baty_navigation/macros/menu',
        'here/baty_slot/macros/nav_devis',
      
        
        )
    right_slots=(
        'here/baty_slot/macros/list_entreprise',
        'here/baty_slot/macros/list_journaux',
        'here/baty_slot/macros/list_affaire',
        'here/baty_slot/macros/list_devis',
        
        
        )
    base=self.objectValues(['BatyBaseEntreprise'])[0]
    #if base.getProperty('right_slots') is None:
    base.manage_addProperty('right_slots',[],'lines')
    #if base.getProperty('left_slots') is None:
    base.manage_addProperty('left_slots',[],'lines')
    base.manage_changeProperties(**{'right_slots':right_slots,'left_slots':left_slots})
    #base._updateProperty('left_slots', left_slots)
    #base._updateProperty('right_slots', right_slots)




    
def setup_workflow_devis(self,out):
    """ mis a jour du devis workflow """
    workflow_tool = getToolByName(self, 'portal_workflow')
    if 'baty_devis' in workflow_tool.objectIds():
        ## on le supprime
        workflow_tool.manage_delObjects( ['baty_devis',])
    
     

    wf=DCWorkflowDefinition('baty_devis')
    ## voir Products/DCWorkflow/Defaults
    ## permission gerer par le workflow
    workflow_tool._setObject('baty_devis',wf)
    wf=workflow_tool.baty_devis
    wf.permissions+=(
        BatyPermissions.ADD_BATY_CONTENT,
        CMFCorePermissions.ModifyPortalContent,
        CMFCorePermissions.AddPortalContent,
        'Delete objects',
        'Copy or Move')

    ## definition des etats
    for s in ('archive','cloture','creation','enattente','affaire','revision'):
        wf.states.addState(s)
    ## definition des transitions
    for t in ('accepter','archiver','cloturer','envoyer','rejeter','reviser','situer'):
        wf.transitions.addTransition(t)
    for v in ('time','actor','action','review_history','comments','situation','acomptes'):
        wf.variables.addVariable(v)
        ## definition de l'etat initial
    wf.states.setInitialState('creation')

    ## setup des etats
    

  

    sdef = wf.states['creation']
    sdef.setProperties(
        title='En Creation',
        transitions=('envoyer',))
    
    
    sdef.setPermission('Delete Objects', 1, ('Manager','Owner','Baty manager','Baty secretaire' ))

    sdef = wf.states['cloture']
    sdef.setProperties(
        title='Cloture',
        transitions=('archiver',)
        
        )
    
    sdef.setPermission('Delete objects', 0, ('Manager',))
    sdef.setPermission('Copy or Move',0,('Manager',))
    sdef.setPermission(CMFCorePermissions.ModifyPortalContent,0,('Manager',))
    sdef.setPermission(CMFCorePermissions.AddPortalContent ,0,('Manager',))


    sdef = wf.states['archive']
    sdef.setProperties(
        title='Archive',
        )
    
    sdef = wf.states['enattente']
    sdef.setProperties(
        title='En attente',
        transitions=('accepter','rejeter','reviser'),
        
        )


    sdef = wf.states['affaire']
    sdef.setProperties(
        title='En affaire',
        transitions=('situer',),
        )
    


    

    sdef = wf.states['revision']
    sdef.setProperties(
        title='En etude',
        transitions=('envoyer',),
        
        )



    

    
    ### definition des transitions

    tdef = wf.transitions['accepter']
    tdef.setProperties(
        title='accept par le client',
        new_state_id='affaire',
        actbox_name='Accepter',
        
        actbox_url='%(content_url)s/baty_devis_accept',
        actbox_category='baty_workflow',
        )


    tdef = wf.transitions['archiver']
    tdef.setProperties(
        title='Le devis est archiver',
        new_state_id='archive',
        actbox_name='Archiver',
        
        actbox_url='%(content_url)s/baty_archive',
        actbox_category='baty_workflow',
        )
    

    tdef = wf.transitions['cloturer']
    tdef.setProperties(
        title='le devis est cloturer',
        new_state_id='cloture',
        actbox_name='Cloturer',
        
        actbox_url='%(content_url)s/baty_mouvement_status_modify?workflow_action=cloturer',
        actbox_category='baty_workflow',
        )

    tdef = wf.transitions['envoyer']
    tdef.setProperties(
        title='envoy au client',
        new_state_id='enattente',
        actbox_name='Envoyer',
        
        actbox_url='%(content_url)s/baty_devis_envoi',
        actbox_category='baty_workflow',
        )

    tdef = wf.transitions['rejeter']
    tdef.setProperties(
        title='rejeter par le client',
        new_state_id='cloture',
        actbox_name='Rejeter',
        
        actbox_url='%(content_url)s/baty_mouvement_status_modify?workflow_action=rejeter',
        actbox_category='baty_workflow',
        )

    tdef = wf.transitions['reviser']
    tdef.setProperties(
        title='demande de rvision du client',
        new_state_id='reviser',
        actbox_name='Reviser',
        
        actbox_url='%(content_url)s/baty_devis_baty_mouvement_status_modify?workflow_action=reviser',
        actbox_category='baty_workflow',
        )


    tdef = wf.transitions['situer']
    tdef.setProperties(
        title='situation des travaux',
        new_state_id='affaire',
        actbox_name='Situer',
        
        actbox_url='%(content_url)s/baty_mouvement_situation',
        actbox_category='baty_workflow',
        )
    tdef.addVariable('situation',"""python:state_change.kwargs.get('situation', '')""")
    
    
    ### definition des variables

    ## variable de workflow
    wf.variables.setStateVar('state_mouvement')
    
    vdef = wf.variables['action']
    vdef.setProperties(description='The last transition',
                       default_expr='transition/getId|nothing',
                       for_status=1, update_always=1)

    vdef = wf.variables['actor']
    vdef.setProperties(description='The ID of the user who performed '
                       'the last transition',
                       default_expr='user/getId',
                       for_status=1, update_always=1)

    vdef = wf.variables['review_history']
    vdef.setProperties(description='Provides access to workflow history',
                       default_expr="state_change/getHistory",
                       props={'guard_permissions':
                              BatyPermissions.BATY_MOUVEMENT + ';' })

    vdef = wf.variables['time']
    vdef.setProperties(description='Time of the last transition',
                       default_expr="state_change/getDateTime",
                       for_status=1, update_always=1)

    
    vdef = wf.variables['comments']
    vdef.setProperties(description='comment about the last transition',
                       default_expr="python:state_change.kwargs.get('comment', '')",
                       for_status=1, update_always=1)

    
    vdef = wf.variables['situation']
    vdef.setProperties(description='Work situation',
                       default_expr="python:state_change.kwargs.get('situation', {})",
                       for_status=1, update_always=0)
    
    print >> out," Installation workflow devis",  wf        






def setup_permission(self,out):
    
    setDefaultRoles(ADD_BATY_CONTENT,())
    setDefaultRoles(EDIT_BATY_CONTENT,())
    setDefaultRoles(VIEW_BATY_CONTENT,())
    setDefaultRoles(VIEW_BATY_JOURNAL,())
    setDefaultRoles(EDIT_BATY_JOURNAL,())
    setDefaultRoles(ADD_BATY_JOURNAL,())
    setDefaultRoles(MANAGE_CONFIGURATION,())
    setDefaultRoles(BATY_MOUVEMENT,())

    setDefaultRoles(VIEW_BATY_AFFAIRE,())
    

    ## ajout des nouveaux role
    self._addRole('Baty secretaire')
    self._addRole('Baty manager')
    
    ### permission au niveau de entreprises - baty permission
    
    self.manage_permission(ADD_BATY_CONTENT,('Manager','Owner','Baty secretaire','Baty manager'))
    self.manage_permission(BATY_MOUVEMENT,('Manager','Baty manager'))
    self.manage_permission(EDIT_BATY_CONTENT, ('Manager','Owner','Baty secretaire','Baty manager'))
    self.manage_permission(VIEW_BATY_CONTENT, ('Manager','Owner','Baty secretaire','Baty manager'))
    self.manage_permission(VIEW_BATY_JOURNAL,('Manager','Owner','Baty secretaire','Baty manager'))
    self.manage_permission(EDIT_BATY_JOURNAL,('Manager','Owner','Baty secretaire','Baty manager'))
    self.manage_permission(ADD_BATY_JOURNAL,('Manager','Baty secretaire','Baty manager'))
    self.manage_permission(MANAGE_CONFIGURATION, ('Manager','Baty manager'))
    self.manage_permission(VIEW_BATY_AFFAIRE, ('Manager','Baty manager'))

    ### permission au niveau de entreprises - cmf permission

    self.manage_permission(CMFCorePermissions.ListFolderContents, ( 'Manager', 'Owner','Baty manager','Baty secretaire'))
    self.manage_permission(CMFCorePermissions.AddPortalContent, ('Manager', 'Owner','Baty manager'))
    self.manage_permission(CMFCorePermissions.AddPortalMember, ('Manager', 'Owner','Baty manager'))



#    portal_types=getToolByName(self,'portal_types')
#    portal_types.Folder.manage_changeProperties({'allowed_content_types':( 'BatyBaseJournal','Document', 'Event', 'Favorite', 'File', 'Folder', 'Image', 'Portlet', 'Topic','BatyDocument'),'filter_content_types':1})
   
    ### conf du portal_factory
    portal_factory=getToolByName(self,'portal_factory')
    portal_factory.manage_setPortalFactoryTypes(listOfTypeIds=('BatyArticle','BatyClient','BatyAffaire','BatyDocument','BatyJournalLigne'))
