from Products.Archetypes.public import *
from Products.Archetypes.Field import ReferenceField
from Globals import InitializeClass
from Products.CMFCore.utils import getToolByName
from Products.Archetypes.config import TOOL_NAME
from Products.Archetypes.debug import log
from Products.Archetypes.utils import DisplayList


class BatyRefField(ReferenceField):
    """A field for containing a reference with a configurable query to catalog"""
    _properties = ReferenceField._properties.copy()
    _properties.update({
        'query':None,
        
        })



    def Vocabulary(self, content_instance=None):
        value = ObjectField.Vocabulary(self, content_instance)
        if value:
            return value
        results = []
        if self.query:
            query=self.query
            if self.allowed_types:
                catalog = getToolByName(content_instance, 'portal_catalog')
                query['Type']=self.allowed_types
            results = catalog(query)
        else:
            archetype_tool = getToolByName(content_instance, TOOL_NAME)
            results = archetype_tool.Content()
        results = [(r, r.getObject()) for r in results]
        value = [(r.UID, obj and (str(obj.Title().strip()) or \
                                  str(obj.getId).strip())  or \
                  log('Field %r: Object at %r could not be found' % \
                      (self.getName(), r.getURL())) or \
                  r.Title or r.UID) for r, obj in results]
        if not self.required:
            value.insert(0, ('', '<no reference>'))
        return DisplayList(value)



InitializeClass(BatyRefField)
