from Products.Archetypes.public import *
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Globals import package_home
from Products.Archetypes.debug import log
import os, os.path
from BatyValidators import isFrenchPhoneNumber,isMobileFrenchPhoneNumber,isNaf,isSiret,isSiren, validQuantite,isFloatandPositive,validStock,isUnique
from BatyPermissions import *
from Products.ArchBaty import CustomizationPolicy 

from Products.validation import validation
#from properties.BatyPropertySheet import manage_addDefault_TVA,  Default_TVA

#print "je passe ici "
## on initialise nos validators
validation.register(isFrenchPhoneNumber('isFrenchPhoneNumber'))
validation.register(isMobileFrenchPhoneNumber('isMobileFrenchPhoneNumber'))
validation.register(isNaf('isNaf'))
validation.register(isSiren('isSiren'))
validation.register(isSiret('isSiret'))
validation.register(validQuantite('validQuantite'))
validation.register(isFloatandPositive('isFloatandPositive'))
validation.register(validStock('validStock'))
validation.register(isUnique('isUnique'))


PROJECTNAME = "ArchBaty"
SKINS_DIRECTORY = 'skins'




# Used by the Install.py external method


# Make the skins available as DirectoryViews
registerDirectory(SKINS_DIRECTORY, globals())

########## tools #####################
from BatyTool import BatyTool


tools = (
    BatyTool,
    )



_types = {}

    
def initialize(context):
    ##Import Types here to register them


    ### pour plone 
    CustomizationPolicy.register(context, globals())

    utils.ToolInit("%s Tool" % PROJECTNAME, tools=tools,
                   product_name=PROJECTNAME,
                   icon="baty_entreprise.gif",
                   ).initialize(context)


#    context.registerClass(Default_TVA,constructors=(manage_addDefault_TVA,))


    
############## Type baty
    import baty_types
    


    
    
    homedir = package_home(globals())
    
    edit_dir = view_dir = os.path.join(homedir, 'skins', 'baty_views')
    script_dir = os.path.join(homedir, 'skins', 'baty_scripts')
    import_dir=os.path.join(homedir, 'import')

    content_types, constructors, ftis = process_types( listTypes(),
                                                       PROJECTNAME,
                                                       
                                                       )
         
    utils.ContentInit(
                PROJECTNAME + ' Content',
                content_types      = content_types,
                permission         = ADD_BATY_CONTENT,
                extra_constructors = constructors,
                fti                = ftis,
                ).initialize(context)
    if 0:
        j_type,j_cons,j_ftis=[],[],[]
        for types in listTypes():
            if types['name']=='BatyBaseJournal':
                j_type,j_cons,j_ftis=process_types((types,),PROJECTNAME,)
  
    
                utils.ContentInit('Baty Journal',
                                  content_types=j_type,
                                  permission= ADD_BATY_JOURNAL,
                                  extra_constructors=j_cons,
                                  fti=j_ftis
                                  ).initialize( context )
    
                      
    
    

    # i=0
#     for types in content_types:
        
        
        
#         if ftis[i]['product']==PROJECTNAME:
#             log("register "+ftis[i]['factory'] +":"+ setup_default_constructor_permission(ftis[i]))
#             utils.ContentInit(
#                 PROJECTNAME + ' Content',
#                 content_types      = (types,),
#                 permission         = setup_default_constructor_permission(ftis[i]),
#                 extra_constructors = (constructors[i],),
#                 fti                = (ftis[i],),
#                 ).initialize(context)
#         i=i+1

project_globals=globals()
