# author : youenn boussard
from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions
from AccessControl import getSecurityManager,Unauthorized 
from Products.ArchBaty import BatyPermissions,PROJECTNAME
from Products.ArchBaty.BatyException import BatyException
from Products.Archetypes.debug import log
from Products.CMFCore.utils import getToolByName
from Products.CMFPlone.PloneFolder import OrderedContainer
from BatyContent import BatyContent
from Products.ArchBaty.BatyUtils import generate_id
import Globals

def safe_cmp(x, y):
    if callable(x): x=x()
    if callable(y): y=y()
    return cmp(x,y)



    
def getBase(self,klass):
    return self.getEntreprise().objectItems(klass)[1]
    


class BatyBase(BaseBTreeFolder,BatyContent):
    """a generic base folder for baty product """
    portal_type = meta_type = 'BatyBase' 
    archetype_name = 'BatyBase'   #this name appears in the 'add' box 
    schema=BaseSchema  + Schema((
        StringField('id',
                    searchable=1,
                    accessor='getId',
                    
                mode='r'),
        StringField('title',isMetadata =1,accessor='Title',searchable=1,
                    widget=StringWidget(label="Identifiant",
                                        
                                    label_msgid="identifiant",
                                    description_msgid="help_identifiant",
                                    i18n_domain="archbaty"),
                    ),
         
        StringField('description',
                    searchable=1,
                    isMetadata =1,
                    widget=TextAreaWidget(format=1,
                                           description='Rentrez la description',
                                           label_msgid="description",
                                           description_msgid="help_description",
                                           label='Description',
                                           i18n_domain="plone")
                    ),
    ))


    actions = (
        {
        'id'           : 'view',
        'name'         : 'View',
        'action'       : 'string:batybase_custom_view',
        'permissions'  : (CMFCorePermissions.ListFolderContents, ),

        },
        
        
        { 'id'            : 'local_roles'
          , 'name'          : 'Local Roles'
          , 'action'        : 'string:${folder_url}/folder_localrole_form'
          , 'permissions'   : (CMFCorePermissions.ManageProperties,)
          , 'category'      : 'object'
        },
         
    )





        
    factory_type_information={
        'allowed_content_types':('BatyFamille',),
        'filter_content_types':1,
        'immediate_view':'batybase_custom_view',
        'content_icon':'configure.png',
        }
    security=ClassSecurityInfo()


    #Methods
    def default_action(self):
        """ retourne l'action par defaut """
        return 'view'

    def debug(self):
        """ for debug only """
        stack=[ (x,str(y)) for x,y in self.__dict__.items() if x!= 'logo' and x!= 'logo_logo' ]
        return stack
        
    
    security.declareProtected(CMFCorePermissions.ListFolderContents,'listBatyBaseListFolderContents' )
    def listBatyBaseListFolderContents( self, spec=None, contentFilter=None, sort_on='creation_date',reverse=1,suppressHiddenFiles=0 ):
        """redefinission de listFolderContents avec l'option de trie"""

        items = self.contentValues(spec=spec, filter=contentFilter)
        #       log([item.creation_date for item in items])
        if sort_on is not None:
            items.sort(lambda x, y: safe_cmp(getattr(x,sort_on),
                                              getattr(y,sort_on)))
        #else:
        #    items.sort(lambda x, y: safe_cmp(getattr(x,'creation_date'),getattr(y,'creation_date')))
#        log([item.creation_date for item in items])
        if reverse:
            items.reverse()

        
        l=[]   
        for obj in items:
            id = obj.getId()
            v = obj
            try:
                if suppressHiddenFiles and id[:1]=='.':
                    raise Unauthorized(id, v)
                if getSecurityManager().validate(self, self, id, v):
                    l.append(obj)
            except (Unauthorized, 'Unauthorized'):
                pass
  #      log([item.creation_date for item in l])
        return l

    
    def folder_contents(self):
        """ return default view """
        return self.view()

    def set_code_num(self):
        """ positionne et retourne le code numerique du prochain article """
        if hasattr(self,'__code_num'):
            setattr(self,'__code_num',int(getattr(self,'__code_num'))+1)
        else:
            setattr(self,'__code_num',1)
        log(getattr(self,'__code_num'))
        return getattr(self,'__code_num')
    
    def get_code_num(self):
        return getattr(self,'__code_num')


    


#    security.setPermissionDefault('Add Baty Content', 'Baty manager')
#    security.setPermissionDefault('Add portal Content','Baty manager')
#    security.setPermissionDefault('View Baty Content','Baty manager')
    
Globals.InitializeClass(BatyBase)



#registerType(BatyBase)# end class BatyBase



class BatyImportExport:
    
    actions =({
        'id'           : 'import/export',
        'name'         : 'Import/Export',
        'action'       : 'string:batybase_custom_import_export',
        'permissions'  : (BatyPermissions.ADD_BATY_CONTENT,),
        'category'      : 'object',
        'visible' : 0,

        },)

    def baty_export(self,contentFilter=None,list_field=[]):
        """ export the base """
        header=';'.join(list_field)+"\n";
        
        objects=self.listBatyBaseListFolderContents(contentFilter=contentFilter)
        table=[]
        csv=''
        for obj in objects:
            try:
                table.append([
                    str(
                    (
                    obj.getField(field) and  obj.getField(field).get(obj)
                    )
                    or
                    (
                    hasattr(obj,field) and (callable(getattr(obj,field)) and getattr(obj,field)() or getattr(obj,field)) or ''
                    )) for field in list_field])
            
                    
            except Exception,e:
                print "excpetion ",str(e)
        
        for item in table:
            csv=csv +';'.join(item) + "\n"
        return header+csv
        
        
        

    def baty_import(self,file,klass):
        """ import the base
        in : file , a csv file which contents the content of the import
        out : nothing
        """
        allowed_content_type=self.allowedContentTypes()
        fti=None
        errors=[]
        for item in allowed_content_type:
            if klass == item.Title():
                ## on la trouver
                fti=item
                break
        if fti is not None:
            ## on recupere le super schema

            ## maintenant on parse le fichier csv
            ## par defaut la premiere ligne contient les champs a importer
            ## les autres sont la valeur de ses champs
            tab_line=file.readlines()
            tab_line=[ x[:len(x)-1] for x in tab_line ]
            str_attr=tab_line[0]
            

            list_attr=str_attr.split(';')
            number=0
            for item in tab_line[1:]:
                number=number+1
                list=item.split(';')
                kw={}
                i=0
                for attr in list_attr:
                    kw[attr]=list[i]
                    i=i+1
                print "creation de kw",kw
                o=fti.constructInstance(self,kw.pop('id',generate_id(prefix=klass)))
                try:
                    o.update(**kw)
                except Exception, e:
                    errors.append({'num_ligne':number,'ligne':item,'cause':str(e)})
            if errors:
                raise BatyException(BatyException.BATY_JOURNAL_ERREUR_EXPORT,errors)
                    

            
                
                
            
            
        
                


    
    

    

class BatyBaseEntreprise(BatyBase,):
    """ folder which content entreprise """
    portal_type = meta_type = 'BatyBaseEntreprise' 
    archetype_name = 'BatyBaseEntreprise'   #this name appears in the 'add' box 

    factory_type_information={
        'allowed_content_types':('BatyEntreprise',),
        #'content_icon':'BatyBase.gif',
        'filter_content_types':1,
        'content_icon':'baty_entreprise.gif',
        }
    security=ClassSecurityInfo()



    


    def default_action(self):
        """ retourne l'action par defaut """
        return 'view'
    
registerType(BatyBaseEntreprise)# end class BatyBase


def addBatyBaseAffaire(self,id=None,**kwargs):
    """ factory de construction de la base article """
    o = BatyBaseAffaire('base_affaire', **kwargs)
    o.setTitle('Base Affaire')
    o.setDescription('description_BatyBaseAffaire')
    
    self._setObject('base_affaire', o)
    from BatyAffaire import addBatyStock,addBatyFraisGeneraux
    addBatyStock(self.base_affaire)
    addBatyFraisGeneraux(self.base_affaire)



class BatyBaseAffaire(BatyBase,):
    """ folder which content affaire """
    portal_type = meta_type = 'BatyBaseAffaire' 
    archetype_name = 'BatyBaseAffaire'   #this name appears in the 'add' box 
    
    
        
    factory_type_information={
        'allowed_content_types':('BatyAffaire',),
        #'content_icon':'BatyBase.gif',
        'filter_content_types':1,
        'content_icon':'baty_affaire.png',
        }
    security=ClassSecurityInfo()

    def default_action(self):
        """ retourne l'action par defaut """
        return 'view'
    
registerType(BatyBaseAffaire)# end class BatyBase


def addBatyBaseTache(self,id=None,**kwargs):
    """ factory de construction de la base article """
    o = BatyBaseTache('base_tache', **kwargs)
    o.setTitle('Base Tache')
    o.setDescription('description_BatyBaseTache')
    self._setObject('base_tache',o)
    
class BatyBaseTache(BatyBase,):
    """ folder which content tache """
    portal_type = meta_type = 'BatyBaseTache' 
    archetype_name = 'BatyBaseTache'   #this name appears in the 'add' box 
    
    
        
    factory_type_information={
        'allowed_content_types':('BatyTache','BatyPrime'),
        #'content_icon':'BatyBase.gif',
        'filter_content_types':1,
        'content_icon':'folder2_green.png',
        }
    security=ClassSecurityInfo()

    def default_action(self):
        """ retourne l'action par defaut """
        return 'view'
    
registerType(BatyBaseTache)# end class BatyBase



def addBatyBaseArticle(self,id=None,**kwargs):
    """ factory de construction de la base article """
    
    o = BatyBaseArticle('base_article', **kwargs)
    o.setTitle('Base Article')
    o.setDescription('description_BatyBaseArticle')
    self._setObject('base_article', o)
    o=getattr(self,'base_article')
    o.create_baty_article()

    

class BatyBaseArticle(BatyBase,BatyImportExport):
    """ folder wich content article with family """ 
    portal_type = meta_type = 'BatyBaseArticle' 
    archetype_name = 'BatyBaseArticle'   #this name appears in the 'add' box 

    actions = (
        {
        'id'           : 'view',
        'name'         : 'View',
        'action'       : 'string:batyarticles_custom_view',
        'permissions'  : (CMFCorePermissions.View, ),

        },
        
        )+BatyImportExport.actions

    
        
    factory_type_information={
        'allowed_content_types':('BatyArticle',),
        'filter_content_types':1,#'content_icon':'BatyBase.gif',
        'content_icon':'folder2_green.png',
        }
    security=ClassSecurityInfo()


    
        


    def getArticleFraisGeneraux(self):
        """ retourne l'article frais generaux """
        try:
            return self.objectValues('BatyArticleFraisGeneraux')[0]
        except:
            raise BatyException(BatyException.BATY_ERREUR_FRAIS_GENERAUX)

    def getArticleFraisStockage(self):
        """  retourne l'article frais de stockage """
        try:
            return self.objectValues('BatyArticleFraisStockage')[0]
        except:
            raise BatyException(BatyException.BATY_ERREUR_FRAIS_STOCKAGE)

    def getArticleCredit(self):
        """  retourne l'article credit """
        try:
            return self.objectValues('BatyArticleCredit')[0]
        except:
            raise BatyException(BatyException.BATY_ERREUR_CREDIT)
    
    
    def create_baty_article(self):
        """ cree les trois type de credit de base d'une base article"""
#        from BatyArticle import addBatyArticleFraisStockage,addBatyArticleFraisGeneraux,addBatyArticleCredit
#        addBatyArticleFraisStockage(self)
#        addBatyArticleFraisGeneraux(self)
#        addBatyArticleCredit(self)
    
            
        
    
registerType(BatyBaseArticle)# end class BatyBase
    

def addBatyBaseClient(self,id=None,**kwargs):
    """ factory de construction de la base client """
    
    o = BatyBaseClient('base_client', **kwargs)
    o.setTitle('Base Client')
    o.setDescription('description_BatyBaseClient')
    self._setObject('base_client', o)

class BatyBaseClient(BatyBase,):
    """ folder which content client """
    portal_type = meta_type = 'BatyBaseClient' 
    archetype_name = 'BatyBaseClient'   #this name appears in the 'add' box 
    
    
        
    factory_type_information={
        'allowed_content_types':('BatyClient',),
        #'content_icon':'BatyBase.gif',
        'filter_content_types':1,
        'content_icon':'folder2_grey.png',
        }

    actions=(
        {
		'id'           : 'view',
		'name'         : 'Base client',
		'action'       : 'string:batyclients_custom_view',
		'permissions'  : (CMFCorePermissions.View, ),
		'category'      : 'object',

	},
        )

    

    security=ClassSecurityInfo()
registerType(BatyBaseClient)

def addBatyBaseSalarie(self,id=None,**kwargs):
    """ factory de construction de la base client """
    
    o = BatyBaseSalarie('base_salarie', **kwargs)
    o.setTitle('Base Salarie')
    o.setDescription('description_BatyBaseSalarie')
    self._setObject('base_salarie', o)
    
class BatyBaseSalarie(BatyBase,):
    """ folder which content client """
    portal_type = meta_type = 'BatyBaseSalarie' 
    archetype_name = 'BatyBaseSalarie'   #this name appears in the 'add' box 
    
    
        
    factory_type_information={
        'allowed_content_types':('BatySalarie',),
        #'content_icon':'BatyBase.gif',
        'filter_content_types':1,
        'content_icon':'folder2_violet.png',
        }
    security=ClassSecurityInfo()

    
registerType(BatyBaseSalarie)# end class BatyBase
     
        
def addBatyBaseDevis(self,id=None,**kwargs):
    """ factory de construction de la base client """
    
    o = BatyBaseDevis('base_devis', **kwargs)
    o.setTitle('Base Devis')
    o.setDescription('description_BatyBaseDevis')
    self._setObject('base_devis', o)



class BatyBaseDevis(BatyBase,):
    """ folder which content devis"""
    portal_type = meta_type = 'BatyBaseDevis' 
    archetype_name = 'BatyBaseDevis'   #this name appears in the 'add' box 
    

    actions=BatyBase.actions + (
                {
		'id'           : 'copy',
		'name'         : 'Copy',
		'action'       : 'string:folder_copy:method',
		'permissions'  : ('Copy or Move', ),
		'category'      : 'baty_folder_buttons',

                },
                {
        	'id'           : 'paste',
		'name'         : 'Paste',
		'action'       : 'string:folder_paste:method',
                
		'permissions'  : (CMFCorePermissions.AddPortalContent, ),
		'category'      : 'baty_folder_buttons',

                },)

        
    factory_type_information={
        'allowed_content_types':('BatyDevis',),
        #'content_icon':'BatyBase.gif',
        'filter_content_types':1,
        'content_icon':'folder2_red.png',
        }
    security=ClassSecurityInfo()

    
registerType(BatyBaseDevis)# end class BatyBase
     

def addBatyBaseMateriel(self,id=None,**kwargs):
    """ factory de construction de la base client """
    
    o = BatyBaseMateriel('base_materiel', **kwargs)
    o.setTitle('Base Materiel')
    o.setDescription('description_BatyBaseMateriel')
    self._setObject('base_materiel', o)
    
class BatyBaseMateriel(BatyBase,):
    """ folder which content matos"""
    portal_type = meta_type = 'BatyBaseMateriel' 
    archetype_name = 'BatyBaseMateriel'   #this name appears in the 'add' box 
    
    
        
    factory_type_information={
        'allowed_content_types':('BatyMateriel',),
        #'content_icon':'BatyBase.gif',
        'filter_content_types':1,
        'content_icon':'folder2_yellow.png',
        }
    security=ClassSecurityInfo()

registerType(BatyBaseMateriel)# end class BatyBase


def addBatyData(self,id=None,**kwargs):
    """ factory de construction de la base client """
    id='Configuration'
    o = BatyData(id, **kwargs)
    o.setTitle(id)
    o.setDescription('description_BatyData')
    self._setObject(id, o)

    for item,value in getToolByName(self,'baty_tool')['secteur'].propertyItems():

        getattr(self,id).invokeFactory(type_name="BatySecteur",id=item,title=value,description=value)

    for item,value in getToolByName(self,'baty_tool')['coef'].propertyItems():
        
        getattr(self,id).invokeFactory(type_name='BatyCoefficient',id=item,title=item,description=item)
        getattr(getattr(self,id),item).update(**{'title':str(value)+'%','coefficient':str(value)})
        #getattr(getattr(self,id),item).setCoefficient(str(value))

    
    for item,value in getToolByName(self,'baty_tool')['coef_stockage'].propertyItems():
        
        getattr(self,id).invokeFactory(type_name='BatyCoefficientStockage',id=item,title=item,description=item)
        getattr(getattr(self,id),item).update(**{'title':str(value)+'%','coefficient':str(value)})
        #getattr(getattr(self,id),item).setCoefficient(str(value))

    
    for item,value in getToolByName(self,'baty_tool')['famille'].propertyItems():
        
        
        getattr(self,id).invokeFactory(type_name="BatyFamille",id=item,title=value,description=value)
        
    

class BatyHier(BaseFolder,BatyContent):
    """ An hierarchical object """

    
    schema=BatyBase.schema
    
    def getHierName(self):
    	""" RETURN THE NAME OF THE HIER """
        
    	tab=self.getPhysicalPath()
	i=len(tab)-1
	title_tab=[]
        #print "appel de getHierName",tab,type(getattr(self,tab[i],'').aq_base),type(self.aq_base)
    	while type(getattr(self,tab[i],'').aq_base)==type(self.aq_base):
            ### tant que le pere est du meme type que le fils on continue
            ### self est du type Acquisition.ImplicitAcquirerWrapper  et  self.aq_base
            ### est du type BatyHier
		
		title_tab.append(getattr(self,tab[i]).title_or_id())
		i=i-1
	title_tab.reverse()
	title='/'.join(title_tab)
		
    	return title



class BatyData(BatyBase,):
    """ folder which content mato"""
    portal_type = meta_type = 'BatyData' 
    archetype_name = 'BatyData'   #this name appears in the 'add' box 
    
    	
        
    factory_type_information={
        'allowed_content_types':('BatyFamille','BatyCoefficient','BatySecteur','BatyCoefficientStockage'	),

        'content_icon':'configure.png',
        'filter_content_types':1,    
        }
    security=ClassSecurityInfo()

    actions =(
		{
		'id'           : 'view',
		'title'         : 'Famille',
		'action'       : 'string:batyfamille_configure',
		'permissions'  : (BatyPermissions.MANAGE_CONFIGURATION, ),
		'category'      : 'object',
                'visible' : 1,
		},
		
                 
		
		{
		'id' : 'coefficient',
		'title' : 'Coefficient Frais gnraux',
		'action' : 'string:batycoef_configure',
		'permissions'  : (BatyPermissions.MANAGE_CONFIGURATION, ),
		'category'      : 'object',
		'visible' : 1,
		},

                {
		'id' : 'coefficient_stock',
		'title' : 'Coefficient Frais stockage',
		'action' : 'string:batycoef_stock_configure',
		'permissions'  : (BatyPermissions.MANAGE_CONFIGURATION, ),
		'category'      : 'object',
		'visible' : 1,
		},

                
                {
		'id' : 'secteur',
		'title' : 'Secteur',
		'action' : 'string:batysecteur_configure',
		'permissions'  : (BatyPermissions.MANAGE_CONFIGURATION, ),
		'category'      : 'object',
		'visible' : 1,
		},

                {
                'id'           : 'edit',
		'title'         : 'Edit',
		'action'       : 'string:${object_url}/portal_form/base_edit',
		'permissions'  : (BatyPermissions.EDIT_BATY_CONTENT, ),
		'category'      : 'object',
                'visible' : 0,
                },
                {
                'title'           : 'Properties',
		'id'         : 'metadata',
		'action'       : 'string:${object_url}/portal_form/base_metadata',
		'permissions'  : (CMFCorePermissions.ModifyPortalContent, ),
		'category'      : 'object',
                'visible' : 0,
                },
                {
                'title'           : 'References',
		'id'         : 'references',
		'action'       : 'string:${object_url}/portal_form/reference_edit',
		'permissions'  : (CMFCorePermissions.ModifyPortalContent, ),
		'category'      : 'object',
                'visible' : 0,
                },

                
		)

    
        

    
registerType(BatyData)# end class BatyBase
     


