from Products.Archetypes.public import BaseContent,BaseSchema,Schema,ClassSecurityInfo,registerType
from Products.Archetypes.config import TOOL_NAME
from Products.CMFCore.utils import getToolByName
from Products.ArchBaty.BatyException import BatyException
from Products.ArchBaty import BatyPermissions 
from Products.Archetypes.debug import log
import traceback


class BatyContent:
    """ base class for all the baty class """

    security=ClassSecurityInfo()

    actions=(
        {
        'id'           : 'edit_popup',
        'name'         : 'edit_popup',
        'action'       : 'string:${object_url}/baty_edit_popup',
        'permissions'  : (BatyPermissions.EDIT_BATY_CONTENT, ),
        'visible' : 0,
        },
	)
    
    
    def getObjectFromAttr(self,attr):
        """ return an object by his uid """
        archetype_tool = getToolByName(self, TOOL_NAME)
        if hasattr(self,attr):
            return archetype_tool.getObject(uid=getattr(self,attr))
        else:
            return None

    def debug(self):
        """ for debug only """
        stack=[ (x,str(y)) for x,y in self.__dict__.items() ]
        return stack

    def introspect(self):
        """ for debug """
        s="\n"
        s=s+ "===================================" + "\n"
        s=s+ """       introspection de %s         """ % (self.title_or_id(),) +"\n"
        for item in self.Schema().fields():
            if item and item.getAccessor(self):
                try:
                    s= s + str(item.getName()) + '  => ' + str(item.getAccessor(self)()) + "\n"
                except Exception , e:
                    print "erreur dans",  item,  item.getAccessor(self)
                    print traceback.print_exc()
                
        s=s+"===========   Fin  ================" + "\n"
        return s

    def getArchetypeTool(self):
        """ retourne l'outil archetype """
        return getToolByName(self, TOOL_NAME)

    def getCatalogTool(self):
        return getToolByName(self,'portal_catalog')


    def getObjFromUid(self,UID=None):
        if UID is not None:
            return self.getArchetypeTool().getObject(UID)
        else:
            return None

    def getMetadataFromUid(self,uid,meta,catalog_name="portal_catalog"):
        """ retourne un meta du dictionniaire """
        br=self.getCatalogTool(catalog_name).search({'UID':uid})
        if len(br)==1:
            return getattr(br[0],meta)
        
    
        

    def getMetadataFromAttr(self,attr,meta):
        uid=getattr(self,attr)
        return self.getMetadataFromUid(uid,meta)
        

    def getFieldValue(self,field_name):
        return self.Schema().get(field_name).getAccessor(self)()


    def getDefaultCodeNum(self):
        """ pour test """
        portal_type=self.portal_type
        
        entreprise=self.getEntreprise()

        brs=self.getCatalogTool().search({'portal_type':portal_type,
                                          'path':'/'.join(entreprise.getPhysicalPath()),
                                          },sort_index='code_num', reverse=1,limit=1)
        if brs:
            return brs[0].code_num+1
        else:
            return 1
