# generated by ArchGenXML Wed Jul  2 19:51:00 2003
from BatyObject import BatyObject, BatyHier
from Products.ArchBaty.properties import BatyFields
from Products.ArchBaty import BatyPermissions
from Products.Archetypes.public import Schema,registerType
from Products.ArchBaty.BatyUtils import addObject
from BatyContent import BatyContent
from BatyBase import BatyBase
from AccessControl import ClassSecurityInfo

from Products.CMFCore import CMFCorePermissions
from Products.Archetypes.debug import log, log_exc
from Products.Archetypes.CatalogMultiplex import CatalogMultiplex
from Acquisition import aq_base


from Products.CMFCore.utils import getToolByName
from Products.ArchBaty.interfaces.IBatyDevisContent import IBatyDevisContent


CONTENT_DEVIS_CONTENT_TYPE=['BatyLigneProduit','BatyLigneProduitHeure']
FOLDER_DEVIS_CONTENT_TYPE=['BatySection','BatyProduit']
ORDER_INCREMENT=10

    
def get_objects_with_sort(objs):
    object_values=list(objs)
    object_values.sort(lambda x,y:
                       cmp(getattr(x,'getOrder') and x.getOrder() or 0,
                           getattr(y,'getOrder') and y.getOrder() or 0))
    return object_values


def __prixDevis(obj,hash_prix,niv=0,index=0,detail=0):
    """fournit les prix des differents element du devis
    give the price of each piece of estimate
    """
    #print "calcul devis pour ",obj,detail

    if detail:
        ## on veut le detail par article
        #print "on est dans le detail"
        if obj.portal_type in CONTENT_DEVIS_CONTENT_TYPE:
            ## on est dans le detail
            hash_prix[obj.UID()]={}
            hash_prix[obj.UID()]=obj.getResults()
        else:
            ## on est pas dans le detail et donc on initialise tous le monde a 0
            hash_prix[obj.UID()]=obj.init_getResults()
    else:
        
        
    
        if obj.portal_type == 'BatyProduit':
        
            hash_prix[obj.UID()]=obj.getResults()
            
        else:
            hash_prix[obj.UID()]=obj.init_getResults()
        
        
    hash_prix[obj.UID()]['niv']=niv
    hash_prix[obj.UID()]['index']=len(hash_prix.keys())
    hash_prix[obj.UID()]['Title']=obj.Title()
    hash_prix[obj.UID()]['url']=obj.absolute_url()
    hash_prix[obj.UID()]['icon']=obj.getIcon(1)
    hash_prix[obj.UID()]['getId']=obj.getId()
    hash_prix[obj.UID()]['meta_type']=obj.meta_type
    hash_prix[obj.UID()]['tva']=obj.getCoefficient_tva()
    hash_prix[obj.UID()]['tva_id']=getattr(obj,'tva','')	
    hash_prix[obj.UID()]['coef']=obj.getCoefficient_vente()
    hash_prix[obj.UID()]['quantite']=obj.getQuantite()
    
    hash_prix[obj.UID()]['description']=obj.Description()
    hash_prix[obj.UID()]['unite']=hasattr(obj,'getUnite') and obj.getUnite() or ''
    hash_prix[obj.UID()]['order']=hasattr(obj,'getOrder') and obj.getOrder() or 0
    if detail:
        portal_types=FOLDER_DEVIS_CONTENT_TYPE + CONTENT_DEVIS_CONTENT_TYPE
    else:
        
        portal_types=FOLDER_DEVIS_CONTENT_TYPE
    for item in get_objects_with_sort(obj.objectValues(portal_types)):
        
        #print obj,obj.UID(),hash_prix[obj.UID()]
        index=index+1

        ## recursive call to the next item ...
        __prixDevis(item,hash_prix,niv=niv+1,index=index,detail=detail)
        
        hash_prix[obj.UID()]['prix']+=hash_prix[item.UID()]['prix']*obj.getQuantite()
        hash_prix[obj.UID()]['marge']+=hash_prix[item.UID()]['marge']*obj.getQuantite()
        hash_prix[obj.UID()]['margec']+=hash_prix[item.UID()]['margec']*obj.getQuantite()
        
        hash_prix[obj.UID()]['heure']=obj.getNbHeure()
	hash_prix[obj.UID()]['ttc']+=hash_prix[item.UID()]['ttc']*obj.getQuantite()
        
        


    
        
def getDevisElementPrix(devis=None,detail=0):
    """ fournit les differents prix du devis sous forme d'un tableau
    si detail =1  on renvoie le detail du devis
    """
    
    
    hash_prix={}

    __prixDevis(devis,hash_prix,detail=detail)

    l=hash_prix.items()
    l.sort(lambda x, y : cmp(x[1]['index'],y[1]['index']))
    return l






class BatyDevisContent(BatyContent,):
    
    schema=BatyObject.schema + Schema((BatyFields.description_commercial(),
                                       BatyFields.tva(),
                                       BatyFields.coefficient_vente(),
                                       BatyFields.coefficient_marge(),
                                       BatyFields.prix_total_devis() 
                                       
                                       ))


    
    actions = (
        {
        'id'           : 'view',
        'name'         : 'View',
        'action'       : 'string:${object_url}/batydevis_custom_view',
        'permissions'  : (BatyPermissions.VIEW_BATY_CONTENT, ),

        },
        
        ) +(
        {
        'id'           : 'report',
        'name'         : 'Report',
        'action'       : 'python:object.getDevis().absolute_url()+"/report"',
        'permissions'  : (BatyPermissions.VIEW_BATY_CONTENT, ),
        'category'     : 'document_actions',

        },

	{
        'id'           : 'rd',
        'name'         : 'Synthese',
        'action'       : 'python:object.getDevis().absolute_url()+"/baty_devis_resume_detail"',
        'permissions'  : (BatyPermissions.VIEW_BATY_CONTENT, ),
        'category'     : 'object',

        },
	
        
        ) + BatyContent.actions +  (
                {
		'id'           : 'copy',
		'name'         : 'Copy',
		'action'       : 'string:baty_folder_copy:method',
		'permissions'  : ('Copy or Move', ),
		'category'      : 'baty_folder_buttons',

                },
                {
        	'id'           : 'paste',
		'name'         : 'Paste',
		'action'       : 'string:baty_folder_paste:method',
                
		'permissions'  : (CMFCorePermissions.AddPortalContent, ),
		'category'      : 'baty_folder_buttons',

                },
                
                )



    
    security=ClassSecurityInfo()

    #Methods
    
    security.declarePublic('getCoefficient_vente')
    def getCoefficient_vente(self):
        """ retourne le coefficient du pere si il n'existe pas au niveau de l'objet en question"""
        return self.getAttrFromParent('coefficient_vente')

    security.declarePublic('getCoefficient_marge')
    def getCoefficient_marge(self):
        """ retourne le coefficient du pere si il n'existe pas au niveau de l'objet en question"""
        return self.getAttrFromParent('coefficient_marge')

    security.declarePublic('getCoefficient_tva')
    def getCoefficient_tva(self):
	""" retourne le coefficient du pere si il n'existe pas au niveau de l'objet en question"""
	
	baty_tool=getToolByName(self,'baty_tool')
	if hasattr(self,'tva') and not self.tva == "" :
		return baty_tool.get_property('tva',getattr(self,'tva')) or 0.0
	elif isinstance(self,BatyDevis):
		if hasattr(self,'tva'):
			return baty_tool.get_property('tva',getattr(self,'tva'),0.0) or 0.0
		return 0.0
	else:
        	return self.getParentNode().getCoefficient_tva()
	
    security.declarePublic('getId_tva')
    def getId_tva(self):
	""" retourne l'id tva du pere si il n'existe pas au niveau de l'objet en question"""
	
	baty_tool=getToolByName(self,'baty_tool')
	if hasattr(self,'tva') and not self.tva == "" :
		return getattr(self,'tva') 
	elif isinstance(self,BatyDevis):
		return getattr(self,'tva')
	else:
        	return self.getParentNode().getId_tva()
	

    security.declarePublic('getAttrFromParent')
    def getAttrFromParent(self,attrName):
        
        if getattr(self,attrName,0.0):
            return  getattr(self,attrName)
        else:
            parent=self.getParentNode()
            if hasattr(parent,attrName):
                return parent.getAttrFromParent(attrName)
            else:
                return 0.0


    
    def _computePrice(self,method=None):
        """return sum(all price of content) """
        returnValue=0.0
        for item in self.objectValues():
            if hasattr(item,method):
                ## add the child value
                #print "ajoute ",item," ",getattr(item,method)()
                returnValue+=getattr(item,method)()*getattr(item,'getQuantite')()
        return returnValue


    
    def _computeRealQuantite(self,returnValue=1.0):
        """ return the multiplication of all quantity """
        
        if isinstance(self,BatyDevis):
            return returnValue
        else:
            returnValue*=self.getQuantite()
            
            return self.getParentNode()._computeRealQuantite(returnValue)

            
    security.declarePublic('getRealQuantite')
    def getRealQuantite(self):
        return self._computeRealQuantite()

    security.declarePublic('getPrix')
    def getPrix(self):
        """ retourne le prix de revient """
        #log("prix %f %s" % (prix,self.meta_type))
        return self._computePrice(method='getPrix')

    security.declarePublic('getPrixAchat')
    def getPrixAchat(self):
        """ retourne le prix propos au client par le devis """
        return self._computePrice(method='getPrixAchat')
    
    
    security.declarePublic('getPrixVente')
    def getPrixVente(self):
        return self._computePrice(method='getPrixVente')

    
    security.declarePublic('getMarge')
    def getMarge(self):
        return self._computePrice(method='getMarge')

    
    security.declarePublic('getPrixTva')
    def getPrixTva(self):
        return self._computePrice(method='getPrixTva')

     
    security.declarePublic('getNbHeure')
    def getNbHeure(self):
        return self._computePrice(method='containsTache')

    def containsTache(self):
        return self._computePrice(method='containsTache')

    security.declarePublic('getPrixClient')
    def getPrixClient(self):
        return self.getPrixVente() + self.getPrixTva()

    
    security.declarePublic('setCoefficient_vente')	
    def setCoefficient_vente(self,value):
	""" change un coefficient de vente dans toutes une arborescence si elle change """
	#log("onfixe le coeff de vente %s " % (value,))
	value=float(value)
	old_value=getattr(self,'coefficient_vente',-1)
	if old_value != value:
            setattr(self,'coefficient_vente',value)
            for child in self.objectValues(['BatySection','BatyProduit']):
                child.update(**{'coefficient_vente':value})

    
    def setTva(self,value):
        """ change une tva dans toutes une arborescence si elle change """
        old_value=getattr(self,'tva',-1)
        if old_value != value:
            setattr(self,'tva',value)
            for child in self.objectValues(['BatySection','BatyProduit']):
                child.update(**{'tva':value})


    

    security.declarePublic('getHierName')
    def getHierName(self):
        """ retour le nom de l'ement devis par rapport a la hierarchiee """
        hier=[]
        parent=self
        
        while parent.portal_type != 'BatyDevis' and parent.getParentNode() != parent:
            hier.append(parent.Title())
            parent=parent.getParentNode()
        hier.append(parent.Title())
        hier.reverse()
        return '/'.join(hier)

    
    security.declarePublic('getQuantite')
    def getQuantite(self):
        return hasattr(self,'quantite') and self.quantite or 1.0
        
    
    
    def init_getResults(self):
        return {'prix':0.0,'marge':0.0,'margec':0.0,'heure':0.0,'ttc':0.0,'unite':'','quantite':0.0}

    security.declarePublic('getResults')
    def getResults(self):
        return {
            'prix':self.getPrixVente()*self.getQuantite(),
            'marge':self.getMarge()*self.getQuantite(), 
            'margec':0.0, ## non implementer
            'heure':self.getNbHeure(),
            'ttc':self.getPrixTva()*self.getQuantite(),
            'unite':hasattr(self,'getUnite') and self.getUnite() or '',
            'quantite':self.getQuantite(),
            
            }
    
    security.declarePublic('getDevisElementsPrix')
    def getDevisElementsPrix(self,detail=0):
        return getDevisElementPrix(self,detail=detail)


    security.declarePublic('getDevisElementsFamille')
    def getDevisElementsFamille(self):
        portal_catalog=self.getCatalogTool()
        brs=portal_catalog({'Type':CONTENT_DEVIS_CONTENT_TYPE,'path':'/'.join(self.getPhysicalPath())})
        hash_q={}
        for item in brs:
            obj=item.getObject()
            if not hash_q.has_key(obj.getFamille()):
                hash_q[obj.getFamille()]={}
            if not hash_q[obj.getFamille()].has_key(obj.getArticle()):
                
                hash_q[obj.getFamille()][obj.getArticle()]={'quantite':0.0,
                                                            'prix_achat':0.00,
                                                            'prix_revient':0.0,
                                                            'titre':obj.Title(),
                                                            'unite':obj.getUnite()}

            quantite=float(obj.getRealQuantite())    
            hash_q[obj.getFamille()][obj.getArticle()]['quantite']+=quantite
            hash_q[obj.getFamille()][obj.getArticle()]['prix_achat']+=obj.getPrixAchat()*quantite
            hash_q[obj.getFamille()][obj.getArticle()]['prix_revient']+=obj.getPrix()*quantite
        return hash_q


    security.declarePublic('getUnite')
    def getUnite(self):
        if hasattr(self,'unite'):
            return getattr(self,'unite')
        else:
            return ''


    security.declarePublic('getDevisElementsFamilleForReport')
    def getDevisElementsFamilleForReport(self):
        hash_q=self.getDevisElementsFamille()
        tab_q=[]
        index=0
        tab_famille=hash_q.keys()
        tab_famille.sort()
        for key in tab_famille:
            index=len(tab_q)
            tab_q.append({'famille':key,
                          'titre':'',
                          
                          'quantite':'',
                          'unite':'',
                          'prix_revient':0,
                          'prix_achat':0,}
                         )
            tab_element=hash_q[key].keys()
            ## on trie par titre
            tab_element.sort(lambda x,y:cmp(hash_q[key][x]['titre'],hash_q[key][y]['titre']))
            for item in tab_element:
                
                tab_q.append({'famille':'',
                              'titre':hash_q[key][item]['titre'],
                              'quantite':hash_q[key][item]['quantite'],
                              'unite':hash_q[key][item]['unite'],
                              'prix_achat':hash_q[key][item]['prix_achat'],
                              'prix_revient':hash_q[key][item]['prix_revient'],}
                             )
                tab_q[index]['prix_revient']+=hash_q[key][item]['prix_revient']
                tab_q[index]['prix_achat']+=hash_q[key][item]['prix_achat']

        return tab_q
    
    
    
    security.declareProtected('setCoefficient_vente',CMFCorePermissions.ModifyPortalContent)     
    def setCoefficient_vente(self,value):
        """ change un coefficient de vente dans toutes une arborescence si elle change
        
        
        """
        log("onfixe le coeff de vente %s " % (value,))
        #value=0.0
        try:
            value=float(value)
        except ValueError,e:
            pass
        old_value=getattr(self,'coefficient_vente',-1)
        if old_value != value:
            setattr(self,'coefficient_vente',value)
            for child in self.objectValues(['BatySection','BatyProduit']):
                child.update(**{'coefficient_vente':value})

    security.declareProtected('setTva',CMFCorePermissions.ModifyPortalContent) 
    def setTva(self,value):
        """ change une tva dans toutes une arborescence si elle change """
        old_value=getattr(self,'tva',-1)
        if old_value != value:
            setattr(self,'tva',value)
            for child in self.objectValues(['BatySection','BatyProduit']):
                child.update(**{'tva':value})




class BatyDevis(BatyHier,BatyDevisContent):


    portal_type = meta_type = archetype_name = 'BatyDevis' 

    
    schema=BatyDevisContent.schema +Schema(( BatyFields.ref_client(),))

    security=ClassSecurityInfo()

    factory_type_information={
        'allowed_content_types':('BatySection',),
        'filter_content_types':1,
        'immediate_view':'batybase_custom_view',
        'content_icon':'folder_icon_d.png',
        }


    actions=BatyDevisContent.actions + ({
        'id'           : 'reorder',
        'name'         : 'Reorder',
        'action'       : 'string:baty_folder_reorder:method',
        'permissions'  : ('Copy or Move', ),
        'category'      : 'baty_folder_buttons',
        
        },
                                        )
    

    getHierName=BatyDevisContent.getHierName


    security.declarePublic('getDevis')
    def getDevis(self):
        """ return le devis """
        return self


    security.declarePublic('getSituation')
    def getSituation(self):
        """ return the devis situation
        the situation of devis is store in situation workflow variable """

        portal_workflow = getToolByName(self,'portal_workflow')
        situation=dict(portal_workflow.getInfoFor(self,'situation'))
        ##on recupere l'ensemble des produits
        portal_catalog = self.getCatalogTool()
        brs=portal_catalog({'Type':'BatyProduit','path':'/'.join(self.getPhysicalPath())})
        tab=[]
        for br in brs:
            tab.append([br,situation.has_key(br.UID) and float(situation[br.UID]) or 0.0])
        return tab

    security.declarePublic('getSituationGlobalPercent')
    def getSituationGlobalPercent(self):
        """ return the devis percent situation for the slot devis
        """
        release_price=0.0
        tab_situation = self.getSituation()
        for (brain,situation) in tab_situation:
            obj=self.getObjFromUid(brain.UID)
            if obj is not None:
                price=obj.getPrix()
                release_price+=price*(float(situation)/100.0)
        if release_price:
            total_price=self.getPrix()
            return float(release_price)/float(total_price)*100.0
        else:
            return 0.00
        
        

    

    
registerType(BatyDevis)



def reindex_all(object):
    for item in object.objectValues(['BatySection','BatyProduit']):
        item.reindex()
        log("je reindex %s" % str(item))
        reindex_all(item)

def addBatySection(self,id=None,**kwargs):
    
    addObject(self,BatySection,id,**kwargs)
    obj=getattr(self,id)
    if(not kwargs.has_key('order')):
        obj.setOrder(len(self.objectIds())*ORDER_INCREMENT)

class BatySection(BatyHier,BatyDevisContent,):


    portal_type = meta_type = archetype_name = 'BatySection' 

    
    schema=BatyDevisContent.schema + Schema((BatyFields.order(),))

    factory_type_information={
        'allowed_content_types':('BatySection','BatyProduit'),
        'filter_content_types':1,
        'immediate_view':'batybase_custom_view',
        'content_icon':'folder_icon_s.png',
        }
    actions=BatyDevisContent.actions + ({
        'id'           : 'reorder',
        'name'         : 'Reorder',
        'action'       : 'string:baty_folder_reorder:method',
        'permissions'  : ('Copy or Move', ),
        'category'      : 'baty_folder_buttons',
        
        },
                                        )
    


    getHierName=BatyDevisContent.getHierName

    security=ClassSecurityInfo()

    security.declareProtected('setTitle',CMFCorePermissions.ModifyPortalContent)
    def setTitle(self, value,**kwargs):
        #log("on update title dans section")
        setattr(self,'title',value)
        ## on reindex toute les sections et les produits contenu dans la section
        #reindex_all(self)
        
            


            
        
        
    
registerType(BatySection)


def addBatyProduit(self,id=None,**kwargs):
    addObject(self,BatyProduit,id,**kwargs)
    obj=getattr(self,id)
    obj.manage_changeProperties(**{'right_slots':[]})
    if(not kwargs.has_key('order')):
        obj.setOrder(len(self.objectIds())*ORDER_INCREMENT)
    


class BatyProduit(BatyBase,BatyDevisContent):


    _properties=({'id':'title', 'type': 'string', 'mode': 'w'},
                 {'id':'right_slots', 'type': 'lines', 'mode': 'w'},
                 )


    portal_type = meta_type = archetype_name = 'BatyProduit' 

    
    schema=BatyObject.schema + Schema((BatyFields.description_commercial(),
                                       BatyFields.tva(),
                                       BatyFields.unite(),
                                       BatyFields.field_float('quantite',default=1.0),
                                       BatyFields.coefficient_vente(),
                                       BatyFields.coefficient_marge(),
                                       BatyFields.prix_total_devis() ,
                                       BatyFields.order(),
                                       ))

    factory_type_information={
        'allowed_content_types':('BatyLigneProduit','BatyLigneProduitHeure'),
        'filter_content_types':1,
        'immediate_view':'batybase_custom_view',
        'content_icon':'folder_icon_p.png',
        }

    actions=(
        {
        'id'           : 'article',
        'name'         : 'Articles',
        'action'       : 'string:${object_url}/batyproduit_article',
        'permissions'  : (BatyPermissions.ADD_BATY_CONTENT, ),

        },
        {
        'id'           : 'heure',
        'name'         : 'Heures',
        'action'       : 'string:${object_url}/batyproduit_heure',
        'permissions'  : (BatyPermissions.ADD_BATY_CONTENT, ),

        },
        ) + BatyDevisContent.actions

    security=ClassSecurityInfo()


    security.declareProtected('setTitle',CMFCorePermissions.ModifyPortalContent)
    def setTitle(self, value,**kwargs):

        setattr(self,'title',value)




registerType(BatyProduit)


def addBatyLigneProduit(self,id=None,**kwargs):
    addObject(self,BatyLigneProduit,id,**kwargs)

class BatyLigneProduit(BatyObject,BatyDevisContent):


    portal_type = meta_type = content_type = archetype_name = 'BatyLigneProduit' 
    #    __implements__= (IBatyDevisContent,)
    
    schema=BatyObject.schema +    Schema((
        BatyFields.ref_article(),
        BatyFields.field_float('quantite'),
        BatyFields.prix_devis(),
	BatyFields.field_float('prix_achat'),

        
        ))
        
        
    ### Le commercial pourra modifier les quantits  et les prix unitaires ref les stocks

    
    factory_type_information={
        'allowed_content_types':(''),
        'filter_content_types':1,
        'immediate_view':'batybase_custom_view',
        'content_icon':'folder_icon_m.png',
        }

    #    actions=BatyDevisContent.actions 

    def getPrixAchat(self):
        """ retourne le prix unitaire d'une ligne d'article  """
        if self.getArticle() and not getattr(self,'prix_achat',0.0):
            # print self.getTache()
            return self.getPrixBase()
        elif  hasattr(self,'prix_achat'):
	    return getattr(self,'prix_achat')	
        else:
            return 0.0

    def getObjectBase(self):
        """ retourne l'objet qui est reference par l'objet en cours """ 
        return self.getObjectFromAttr('article')

    def getPrixBase(self):
        """ retourne le prix initiale de l'article dans la base article """
        try:
            return self.getObjectBase().getPrix()
        except Exception ,e:
            return 0.0

    def getUnite(self):
        """ retourne l'unite de la reference de l'article """
        return self.getObjectBase().getUnite()
    
    def getPrix(self):
        """ retourne le prix de revient d'une ligne d'article  """
        if self.getArticle() :
            # print self.getTache()
	    coef_generaux= float(self.getObjectBase().getCoefficientValue())	
            prix=self.getPrixAchat()*(1.0+coef_generaux/100)
            #log("prix %f " % (prix,))
            return prix
        else:
            return 0.0




    def getPrixVente(self):
        """ retourne le prix de vente de l'article  c'est a dire celui presenter au client incluant le prix de revient et les differents coefficient affecter au produit et aux sections"""
        return self.getPrix() * (1+self.getCoefficient_vente()/100)*(1+self.getCoefficient_marge()/100)

  
    def getMarge(self):
        """ retourne la marge affecter  l'article """
        return self.getPrix()*(self.getCoefficient_vente()/100)

    
    def getMargeCommercial(self):
        """ retourne la marge commercial """
        return self.getPrix()*(1+self.getCoefficient_vente()/100)*(self.getCoefficient_marge()/100)

    def getPrixTva(self):
        """ retourne la quote part tva """
        return self.getPrixVente()*(self.getCoefficient_tva()/100.0)

    

    def getNbHeure(self):
        """ retourne le nombre d'heure """
        return 0.0


    def containsTache(self):
        return 0

    
    def getPrixBase(self):
	""" retourne le prix fichier """
	if self.getArticle():
	    return float(self.getObjectBase().getPrix())
             

    def getCoefficient(self):
        """ retourne la valeur du coefficient de frais generaux de  l'article """
        if self.getArticle():
            return self.getObjectBase().getCoefficientValue()
        else:
            return 0.0


    def getFamille(self):
        """ retourne l'identifiant de la famille """
        if self.getArticle():
            return (self.getObjectBase().getObjectFromAttr('famille').Title())

    





registerType(BatyLigneProduit)






def addBatyLigneProduitHeure(self,id=None,**kwargs):
    addObject(self,BatyLigneProduitHeure,id,**kwargs)

class BatyLigneProduitHeure(BatyLigneProduit):

    portal_type = meta_type = content_type = archetype_name = 'BatyLigneProduitHeure' 


    schema=BatyObject.schema +    Schema((
        BatyFields.reference_tache(),
        BatyFields.field_float('quantite'),
        BatyFields.prix_devis(),
	BatyFields.field_float('prix_achat'),
        
        ))
        
        

    factory_type_information={
        'allowed_content_types':(''),
        'filter_content_types':1,
        'immediate_view':'batybase_custom_view',
        'content_icon':'folder_icon_h.png',
        }

    


    def getObjectBase(self):
        """ retourne l'objet qui est reference par l'objet en cours """ 
        return self.getObjectFromAttr('tache')

    
    
    ## pour l'indexation catalog
    def getArticle(self):
        return self.getTache()

    

    def getNbHeure(self):
        return self.getQuantite()

    def containsTache(self):
        return 1
    
registerType(BatyLigneProduitHeure)

    

             

