# 	$Id: BatyEntreprise.py,v 1.12 2006-10-25 21:48:01 youenn Exp $	
from AccessControl import Permissions, getSecurityManager, ClassSecurityInfo, Unauthorized

from Products.CMFCore.CMFCorePermissions import View, ManageProperties, ListFolderContents
from Products.Archetypes.public import *
from Products.Archetypes.config import TOOL_NAME
from Products.Archetypes.debug import log

from Products.CMFCore.utils import getToolByName
from AccessControl import ClassSecurityInfo
from Products.CMFCore import CMFCorePermissions
from Products.CMFPlone.LargePloneFolder import LargePloneFolder


from Products.CMFCore.CMFCorePermissions import  View, ManageProperties, ListFolderContents
from Products.ArchBaty.BatyException import BatyException
from DateTime import DateTime
from BatyBase import BatyBase
from Products.ArchBaty.BatyUtils import *
from BatyBase import addBatyBaseAffaire, addBatyBaseArticle, addBatyBaseClient, addBatyBaseSalarie, addBatyBaseDevis, addBatyBaseMateriel, addBatyData, addBatyBaseAffaire, addBatyBaseTache		     
from BatyJournal import addBatyBaseJournal

from Products.ArchBaty.properties import BatyFields

def addBatyEntreprise(self, id, **kwargs):
	"""add a new entreprise to a plone folder"""
	o = BatyEntreprise(id, **kwargs)
	self._setObject(id, o)
	"""we must get the new reference of the object in zodb (else bug in refereancable)"""
        #for item in self.objectItems():
        #        if item[0] == id:
        #                instance=item[1]

	instance=getattr(self,id)
        ## creations des base ###

	addBatyBaseArticle(instance)
	addBatyBaseAffaire(instance)
	addBatyBaseClient(instance)
	addBatyBaseDevis(instance)
	addBatyBaseSalarie(instance)
	addBatyBaseTache(instance)
	addBatyData(instance)
	addBatyBaseJournal(instance,'base_journal',title='Base Journal')
	
	## on rajoute un folder pour la documentation
	dc=LargePloneFolder(id='document',title='Document')
        instance._setObject('document', dc)
        
                        


class BatyEntreprise(BatyBase):
	"""Represente une entreprise gerer par baty"""
	content_type = portal_type = meta_type ="BatyEntreprise"
        archetype_name ="BatyEntreprise"
	#schema = schema
	content_icon='baty_entreprise.gif'


	schema = BaseSchema + Schema((BatyFields.id(),
				      BatyFields.title_entreprise(),
				      BatyFields.adresse(),
				      BatyFields.code_postal(),
				      BatyFields.ville(),
				      BatyFields.telephone(),
				      BatyFields.portable(),
				      BatyFields.email(),
				      BatyFields.code_naf(),
				      BatyFields.code_siren(),
				      BatyFields.code_siret(),

				      BatyFields.logo(),
				      BatyFields.print_footer(),
				      ))


	security=ClassSecurityInfo()
	

	factory_type_information={
		'allowed_content_types':(),
       
		'filter_content_types' : 1,
		'immediate_view':'batyentreprise_custom_view'
        }
    

	actions = (
		{
		'id'           : 'view',
		'name'         : 'Entreprise',
		'action'       : 'string:batyentreprise_custom_view',
		'permissions'  : (CMFCorePermissions.View, ),
		'category'      : 'object',

		},
		
		
		{
		'id' : 'configuration',
		'name' : 'Configuration',
		'action' : 'Configuration/view',
		'permissions'  : (CMFCorePermissions.View, ),
		'category'      : 'object',
		'visible' : 1,
		},
		)


	security.declarePublic('default_action')
        def default_action(self):
                """ retourne l'action par defaut """
                return 'view'

	security.declarePublic('getBaseArticle')
        def getBaseArticle(self):
                """return the ref base article"""
                return self.objectItems('BatyBaseArticle')[0][1]

	

	security.declarePublic('getBaseClient')
	def getBaseClient(self):
		return self.objectItems('BatyBaseClient')[0][1]

	security.declarePublic('get_default_base_type')
	def get_default_base_type(self,objectType):
		if objectType == 'BatyPrime':
			return 'BatyTache'
		else:
			return objectType
		
		

	security.declarePublic('Description2')
        def Description2(self):
                """ retourne la description  """
                return 'adresse : %s %s %s' % (self.getAdresse(),str(self.getCode_postal()),self.getVille())

                
        security.declarePublic('getDestination')
        def getDestination(self,objectType):
                """ return the good container for the type : convention an BatyType is contained in a BatyBaseType"""
		log('getDestination')
		objectType=self.get_default_base_type(objectType)

		
                base=objectType[:4]+'Base'+objectType[4:]
		
                l=self.objectItems(base)
                if self.objectItems(base):
                        return self.objectItems(base)[0][1]
		
			
		
		else:
			log('je passe dans le else')
			if(objectType == 'BatyDocument'):
				
				return self.document
			else:
				return self.Configuration

	security.declarePublic('getConfiguration')
	def getConfiguration(self):
		""" retourne le conteneur des familles , secteur , affaire """
		return self.objectItems('BatyData')[0][1]
                
                
                

                
        security.declarePublic('format_date')
	def format_date(self,date):
                return date.strftime('%d/%m/%Y')

		
        security.declarePublic('get_date_debut_exercice')
	def get_date_debut_exercice(self):
                """ return date """
                return self.format_date(getattr(self,'date_debut_exercice',DateTime()))

                

        security.declarePublic('get_date_fin_exercice')
	def get_date_fin_exercice(self):
                """ return date """
                return self.format_date(getattr(self,'date_fin_exercice',DateTime()))
        
        security.declarePublic('get_premier_an')
	def get_premier_an(self):
                """ return date """
                return self.format_date(getattr(self,'premier_an',DateTime()))

        security.declarePublic('makeQuery')
	def makeQuery(self,type=None):
                #log("query : %s" % str( {'Type':type,'path':'/'.join(self.getPhysicalPath())}))
                return {'Type':type,'path':'/'.join(self.getPhysicalPath())}
                

	security.declarePublic('getListType')
	def getListType(self,type=None):
		q=self.makeQuery(type)
		catalog = getToolByName(self, 'portal_catalog')
                return catalog(q)

	security.declarePublic('getFirstObjectForType')
	def getFirstObjectForType(self,type=None):
		""" pour tester """
		try:
			return getToolByName(self, 'portal_catalog')(self.makeQuery(type=type))[0].getObject()
		except:
			return None

	security.declarePublic('getArchetypeTool')
	def getArchetypeTool(self):
		""" retourne l'outil archetype """
		return getToolByName(self, TOOL_NAME)


	
		      

        security.declarePublic('getListFamille')
	def getListFamille(self,root=0):
		""" pour tester """ 
		return self.getListHierObject(type=('BatyFamille'),root=root)
                
                
	security.declarePublic('getListHierObject')
	def getListHierObject(self,type=[],root=0):
		""" return an hierachical list """
		query=self.makeQuery(type=type)
		catalog= getToolByName(self, 'portal_catalog')
		results=catalog(query)
		if root:
			results = [(r.UID, '>'+r.getObject().getHierName()) for r in results]
		else:
			results = [(r.UID, r.getObject().getHierName()) for r in results]
		results.sort(lambda x,y:cmp(x[1],y[1]))
		if root:
			conf=self.getConfiguration()
			results=[(conf.UID(),conf.title_or_id())]+results
		return DisplayList(results)
	

        security.declarePublic('getListAffaire')
	def getListAffaire(self):
		""" liste des affaires """
                query=self.makeQuery(type=('BatyAffaire','BatyStock'))
                
                
                return self.displayFactory(query)

        security.declarePublic('getListClient')
	def getListClient(self):
                query=self.makeQuery(type='BatyClient')
                
                return self.displayFactory(query)
       
        
        security.declarePublic('getListArticle')
	def getListArticle(self):
                query=self.makeQuery(type='BatyArticle')
		return self.displayFactory(query,description=1)

	security.declarePublic('getListSalarie')
	def getListSalarie(self):
		""" retourne la liste des salarie """
                query=self.makeQuery(type='BatySalarie')
		return self.displayFactory(query,description=1)
		
	security.declarePublic('getListTache')
	def getListTache(self):
		""" retourne la liste des taches """
                query=self.makeQuery(type='BatyTache')
		return self.displayFactory(query,description=1)
	
	

	security.declarePublic('getListSecteur')
	def getListSecteur(self,root=0):
		""" retourne la liste des secteur """
		return self.getListHierObject(type=('BatySecteur'),root=root)
		#query=self.makeQuery(type='BatySecteur')
		#return self.displayFactory(query)


        security.declarePublic('getListCoefficient')
	def getListCoefficient(self):
                query=self.makeQuery(type='BatyCoefficient')
                
                return self.displayFactory(query)


	security.declarePublic('getListCoefficientStockage')
	def getListCoefficientStockage(self):
                query=self.makeQuery(type='BatyCoefficientStockage')
                
                return self.displayFactory(query)
	
		
	security.declarePublic('getListPrime')
	def getListPrime(self):
		""" liste des primes """
                query=self.makeQuery(type='BatyPrime')
                
                return self.displayFactory(query)
		

        security.declarePublic('getListCodeComptable')
	def getListCodeComptable(self):
		return self.baty_tool['compta'].display()

                

        security.declarePublic('getListUnite')
	def getListUnite(self):
		
		return self.baty_tool['unite'].display()

	security.declarePublic('getListTva')
	def getListTva(self):
		
		return self.baty_tool['tva'].display()

                
        security.declarePublic('getListDocument')
	def getListDocument(self):
                query=self.makeQuery(type='BatyDocument')
                return self.displayFactory(query)


		


        security.declarePublic('getList')
	def getList(self,type=None):
                """return the list document inside this object"""
                query=self.makeQuery(type=type)
                return self.displayFactory(query)

	security.declarePublic('getListAttr')
	def getListAttr(self,type,attr):
		""" return a list of type with the value of attr in value """
		query=self.makeQuery(type=type)
		display=self.displayFactory(query,attr=attr)
		return display
		
			
        security.declarePublic('manage_beforeDel')
	def manage_beforeDel(self):
                return 


        security.declarePublic('getListCatalogArticle')
	def getListCatalogArticle(self):
                """ retourne la liste des articles pour cette entreprise """
                catalog = getToolByName(self, 'portal_catalog')
                return catalog(self.makeQuery(type='BatyArticle'))


        security.declarePublic('getPeriodeEnCours')
	def getPeriodeEnCours(self):
                """ retourne la liste (DisplayList) des priodes en cours
                par defaut la periode n et n+1 sont en cours
                """
                
                # if not hasattr(self,'periode_en_cours'):
#                         list_periode=[prevPeriode(DateTime().month(),DateTime().year()),Periode(DateTime().month(),DateTime().year())]
#                         setattr(self,'periode_en_cours',list_periode)
                        
                        
#                 list_periode=getattr(self,'periode_en_cours')
                return DisplayList([ (str(x), str(x)) for x in self.getPeriodes() ])

	security.declarePublic('getPeriodes')
	def getPeriodes(self):
		""" retourne les periodes en cours de baty """
		if not hasattr(self,'periode_en_cours'):
                        list_periode=[prevPeriode(DateTime().month(),DateTime().year()),Periode(DateTime().month(),DateTime().year())]
                        setattr(self,'periode_en_cours',list_periode)
                        
                        
                list_periode=getattr(self,'periode_en_cours')
                return list_periode

	security.declarePublic('cloturePeriode')
	def cloturePeriode(self,periode_id):
		""" on cloture la periode en cours et on creer un nouveau journal des heures
		priode_id = pair ou impair
		regle : on doit toujours cloturer la premiere periode
		utilisation : function cloture periode de baty tool
		"""

		list_periode=self.getPeriodes()
		
		
		
		if periode_id!=list_periode[0].get_periode_type():
			raise BatyException(BatyException.BATY_CLOTURE_PERIODE)
		
		
		per1=nextPeriode(list_periode[0].month,list_periode[0].year)
		per2=nextPeriode(int(per1.month),int(per1.year))
		setattr(self,'periode_en_cours',[per1,per2])
		return

	
	security.declarePublic('createNewJournal')
	def createNewJournal(self,typeJournal,periodeObject):			
		""" creation d'un nouveau journal """

		
		
		base=self.getDestination('BatyJournal')
		id=generate_id(prefix=typeJournal)
		if typeJournal=='BatyJournal':
			title_prefix='mat '
		else:
			title_prefix='heu '

		new_id=base.invokeFactory(id=id,type_name=typeJournal,
					  title="%s %02d/%04d" % (title_prefix,periodeObject.month,periodeObject.year))
		kw={'periode':str(periodeObject),'date_de_saisie':DateTime()}
		base[id].update(**kw)
        	

	security.declarePublic('getFraisGenerauxAffaire')
	def getFraisGenerauxAffaire(self):
		""" return l'affaire des frais generaux """
		return self.getFirstObjectForType(type='BatyFraisGeneraux')

	def getStockAffaire(self):
		""" return l'affaire du stock """
		return self.getFirstObjectForType(type='BatyStock')
	
	
        
	security.declarePublic('getEntreprise')
	def getEntreprise(self):
		""" retourne l'entreprise : pour l'acquisition"""
		return self

	security.declarePublic('getEnt')
	def getEnt(self):
		""" retourne l'entreprise : pour l'acquisition"""
		return self;

	security.declarePublic('getUidFromId')
	def getUidFromId(self,id,from_obj=None):
		""" retourne l'uid de l'objet depuis un id """
		if  from_obj is None:
			from_obj=self
		path='/'.join(from_obj.getPhysicalPath())
		result=self.portal_catalog.search({'id':id,'path':path})
	
		if len(result)==1:
			return result[0].UID
		else:
			## pas d'unicite
			return None



	security.declarePublic("searchInCatalog")
	def searchInCatalog(self,
			    query={'portal_type':'BatyEntreprise'},
			    attrs=['Title',],
			    catalog=None,
			    context=None,
			    ):
		""" search in catalog with context"""
		catalog=catalog is None and getToolByName(self, 'portal_catalog') or catalog
		if 'path' not in query.keys():
			if context is None:
				context= self
			query.update({'path':'/'.join(context.getPhysicalPath())})
		brs=catalog(query)
		

		results=[(br.UID, '-'.join([ getattr(br,attr,'') for attr in attrs ])) for br in brs ]
		results.sort(lambda x,y:cmp(x[1],y[1]))

		return DisplayList(results)


	
        def displayFactory(self,query=None,description=None,attr=None,catalog=None):
		catalog=catalog is None and getToolByName(self, 'portal_catalog') or catalog
                if query:
                                            
			results = catalog(query)
			
                else:
                        archetype_tool = getToolByName(self, TOOL_NAME)
                        results = archetype_tool.Content()
		if attr:
			results = [(r.UID,getattr(r.getObject(),attr,'-')) for r in results]
			log("resultat = %s" % (str(DisplayList(results))))
			return DisplayList(results)
			
		else:
			
			if not description:
				results = [(r.UID, len(r.Title) and r.Title or r.getId) for r in results]
			#results.sort()
			#results=[(y,x) for (x,y) in results
 		        else:
				results = [(r.UID, len(r.Title) and r.Title + ' - ' + r.Description[:25] or  r.getId) for r in results]
			#results.sort()
		
		results.sort(sorting_by_code_num)
                #log(str(results))
               # value = [(r.UID, obj and (str(obj.Title().strip()) or \
               #                           str(obj.getId().strip())
                #                     or \
                 #                   log('Field %r: Object at %r could not be found' % \
                  #                  (self.getName(), r.getURL())) or \
                   #                 r.Title or r.UID) for r, obj in results]
                
                return DisplayList(results)
                









	

		
registerType(BatyEntreprise)

