from Products.Archetypes.public import BaseContent,BaseSchema,Schema,ClassSecurityInfo,registerType
from Products.Archetypes.config import TOOL_NAME
from Products.CMFCore.utils import getToolByName
from Products.ArchBaty.BatyException import BatyException
from Products.ArchBaty.properties import BatyFields
from Products.CMFCore import CMFCorePermissions
from BatyBase import BatyBase,BatyData,BatyHier
from Products.ArchBaty.BatyUtils import generate_id
from BatyContent import BatyContent
from Products.ArchBaty import BatyPermissions



class BatyObject(BaseContent,BatyContent):
    """ base folder for baty product """
    archetype_name = 'BatyObject'   #this name appears in the 'add' box 
    schema=BaseSchema +  Schema(( BatyFields.id() , BatyFields.title(), BatyFields.description()
        ))
    #Methods

    actions=(
        {
        'id'           : 'edit_popup',
        'name'         : 'edit_popup',
        'action'       : 'string:${object_url}/baty_edit_popup',
        'permissions'  : (BatyPermissions.EDIT_BATY_CONTENT, ),
        'visible' : 0,
        },
	)	
    
    
    security=ClassSecurityInfo()


    

def addBatyCoefficient(self,id=None,**kwargs):
    """ A un coefficient de frais gnraux correspond un code article frais gnraux et un affaire spciale frais gnraux dans le secteur
frais gnraux """
    if id is None:
        id=generate_id('BatyCoefficient')
    o=BatyCoefficient(id,**kwargs)
    self._setObject(id, o)
    o_uid=o.UID()
    ## on cree le super article lie au coefficient
    base_article=self.getBaseArticle()
    id_article_frais=generate_id('BatyArticleFraisGeneraux')
    id_article_credit=generate_id('BatyArticleCredit')
    
    from BatyArticle import addBatyArticleFraisGeneraux,addBatyArticleCredit
    
    addBatyArticleFraisGeneraux(base_article,id=id_article_frais)
    addBatyArticleCredit(base_article,id=id_article_credit)
    frais=base_article[id_article_frais]
    credit=base_article[id_article_credit]
    
    



    kw={'coefficient':o_uid, 'code_alpha':o.title_or_id()}
    frais.update(**kw)
    credit.update(**kw)
    #print a.debug()
    #print "ref article ----------- ",a.UID()
    
    ## pas d'appel a update car le champ est uniquement en read au niveau d'archetype
    o.article_frais=frais.UID()
    o.article_credit=credit.UID()
    
    

    

class BatyCoefficient(BatyObject,):
    """ standard coefficient for baty """
    portal_type = meta_type = 'BatyCoefficient'
    content_icon='configure.png'
    archetype_name = 'BatyCoefficient'   #this name appears in the 'add' box 
    schema=BatyObject.schema  + Schema((BatyFields.ceofficient_value(),
                                        BatyFields.ref_article_frais(),
                                        BatyFields.ref_article_credit()
                                        ))
    
    def getArticleFraisObject(self):
        """ retourne un article frais generaux """
        archetype_tool = getToolByName(self, TOOL_NAME)
        try:
            article=archetype_tool.getObject(self.getArticle_frais())
            #print self.getArticle()
            if article is None:
                raise BatyException('An BatyCoefficient must have a reference to an article frais')
            else:
                return article
        except:
            raise BatyException('An BatyCoefficient must have a reference to an article frais')


        
    def getArticleCreditObject(self):
        """ retourne un article frais generaux """
        archetype_tool = getToolByName(self, TOOL_NAME)
        try:
            article=archetype_tool.getObject(self.getArticle_credit())
            #print self.getArticle()
            if article is None:
                raise BatyException('An BatyCoefficient must have a reference to an article credit')
            else:
                return article
        except:
            raise BatyException('An BatyCoefficient must have a reference to an article credit')



    #Methods
    
registerType(BatyCoefficient)# end class BatyCoefficient




def addBatyCoefficientStockage(self,id=None,**kwargs):
    """ A un coefficient de frais gnraux correspond un code article frais gnraux et un affaire spciale frais gnraux dans le secteur
frais gnraux """
    if id is None:
        id=generate_id('BatyCoefficientStockage')
    o=BatyCoefficientStockage(id,**kwargs)
    self._setObject(id, o)
    o_uid=o.UID()
    ## on cree le super article lie au coefficient
    base_article=self.getBaseArticle()
    id_article_frais=generate_id('BatyArticleFraisStockage')
    id_article_credit=generate_id('BatyArticleCredit')
    
    from BatyArticle import addBatyArticleFraisStockage,addBatyArticleCredit
    
    addBatyArticleFraisStockage(base_article,id=id_article_frais)
    addBatyArticleCredit(base_article,id=id_article_credit)
    frais=base_article[id_article_frais]
    credit=base_article[id_article_credit]
    
    



    kw={'coefficient':o_uid, 'code_alpha':o.title_or_id()}
    frais.update(**kw)
    credit.update(**kw)
    #print a.debug()
    #print "ref article ----------- ",a.UID()
    
    ## pas d'appel a update car le champ est uniquement en read au niveau d'archetype
    o.article_frais=frais.UID()
    o.article_credit=credit.UID()





class BatyCoefficientStockage(BatyCoefficient,):
    """ standard coefficient stockage for baty """
    portal_type = meta_type = 'BatyCoefficientStockage'
    content_icon='configure.png'
    archetype_name = 'BatyCoefficientStockage'   #this name appears in the 'add' box
    schema=BatyCoefficient.schema

    #Methods

registerType(BatyCoefficientStockage)# end class BatyCoefficientStock



    

    
def addBatyFamille(self,id=None,**kwargs):
    if id is None:
        id=generate_id('BatyCoefficient')
    o=BatyFamille(id,**kwargs)
    
    for key in kwargs.keys():
        
        #o.schema[key].set(o,kwargs.get(key))
        setattr(o,key,kwargs.get(key))
    self._setObject(id, o)
    if not kwargs.get('coefficient',0):
        #print self.objectValues('BatyFamille')
        
        #o.schema['coefficient'].set(o,self.Configuration.objectValues('BatyCoefficient')[0].UID())
        setattr(o,'coefficient',self.Configuration.objectValues('BatyCoefficient')[0].UID())
    if not kwargs.get('coefficient_stockage',0):
        #print self.objectValues('BatyFamille')
        #o.schema['coefficient_stockage'].set(o,self.Configuration.objectValues('BatyCoefficient')[0].UID())
        setattr(o,'coefficient_stockage',self.Configuration.objectValues('BatyCoefficientStockage')[0].UID())
        
    


class BatyFamille(BatyHier,):
    """ An object for catalog baty family
    To one family is attach an coefficient"""
    portal_type = meta_type = 'BatyFamille'
    content_icon='configure.png'
    archetype_name = 'BatyFamille'   #this name appears in the 'add' box 
    schema= BaseSchema + Schema((BatyFields.code_famille(),
                                 BatyFields.title(),
                                 BatyFields.description(),
                                 BatyFields.coefficient(),
                                 BatyFields.coefficient_stockage()))

    #actions = BatyBase.actions

    actions=BatyHier.actions
    
    factory_type_information={
        'allowed_content_types':('BatyFamille',),
        'filter_content_types':1,
        'immediate_view':'batybase_custom_view',
        'content_icon':'configure.png',
        }
    security=ClassSecurityInfo()


    
    def setId(self,value):
        container=self.getParentNode()
        container.manage_renameObjects((self.id,),(value,))
        
        setattr(self,'id',value)

    def getCoefficient(self):
        """ default accessor of baty coefficient:
        if none exist setattr to the the first coef """
        if not hasattr(self,'coefficient') and not getattr(self,'coefficient'):
            #print "on passe par la "
            self.schema['coefficient'].set(self,self.getParentNode().objectValues('BatyCoefficient')[0].UID())
            
        return getattr(self,'coefficient')

    def getCoefficientStockage(self):
        """ default accessor of baty coefficient:
        if none exist setattr to the the first coef """
        if not hasattr(self,'coefficient_stockage') and not getattr(self,'coefficient_stockage'):
            #print "on passe par la "
            self.schema['coefficient_stockage'].set(self,self.getParentNode().objectValues('BatyCoefficientStockage')[0].UID())
            
        return getattr(self,'coefficient_stockage')

        
        
    
    #Methods

registerType(BatyFamille)# end class BatyFamille


     



class BatyDocument(BatyObject,):
    portal_type = meta_type = 'BatyDocument' 
    archetype_name = 'BatyDocument'   #this name appears in the 'add' box 
    schema= BatyObject.schema + Schema((BatyFields.pj()))

    #Methods

        
registerType(BatyDocument)#end class BatyArticle


class BatySecteur(BatyHier,):
    """ folder which content matos"""
    portal_type = meta_type = 'BatySecteur' 
    archetype_name = 'BatySecteur'   #this name appears in the 'add' box 
    
    actions=BatyHier.actions  
        
    factory_type_information={
        'allowed_content_types':('BatySecteur',),
        #'content_icon':'BatyBase.gif',
        'filter_content_types':1,
        'content_icon':'configure.png',
        }
    
    security=ClassSecurityInfo()


    def default_action(self):
        """ retourne l'action par defaut """
        return 'view'

registerType(BatySecteur)# end class BatyBase

