from Products.Archetypes.public import *
from DateTime import DateTime

def id(): 
    return StringField('id',
                       
                       mode='')




def code_naf():
    return  StringField('code_naf',
                       required=0,
                       searchable=1 ,
                       schemata='Code',
                       validators='isNaf', 
                       widget=StringWidget(maxlength='5',
                                           size='5',
                                           description_msgid='help_naf',
                                           label_msgid='label_naf',
                                           i18n_domain='archbaty'))


def code_siret():
    return  StringField('code_siret',
                        required=0,
                        searchable=1 ,
                        schemata='Code',
                        validators='isSiret',
                        widget=StringWidget(maxlength='14',
                                            size='16',
                                            description_msgid='help_siret',
                                            label_msgid='label_siret',
                                            i18n_domain='archbaty'
                                            
                                            ))


def code_siren():
    return  StringField('code_siren',
                        required=0,
                        searchable=1 ,
                        schemata='Code',
                        validators='isSiren',
                        widget=StringWidget(maxlength='9',
                                            size='10',
                                            description_msgid='help_siren',
                                            label_msgid='label_siren',
                                            i18n_domain='archbaty'
                                            
                                            ))
    


        
def code_famille():
    return  StringField('id',
                required=1, ## Still actually required, but
                            ## the widget will supply the missing value
                            ## on non-submits
                mode="rw",
                accessor="getId",
                mutator="setId",
                default=None,
                widget=IdWidget(label_msgid="label_code_famille",
                                description_msgid="help_code_famille",
                                i18n_domain="archbaty"),
                        )

def code_alpha():
    return StringField('code_alpha',
                       required= 1 ,
                       searchable=1,
                       widget=StringWidget(
                                           label_msgid="code_alpha",
                                           description_msgid="help_code_alpha",
                                           i18n_domain="archbaty")
                       )


def nom():
    return StringField('nom',
                       required=  1 ,
                       searchable=1,
                       widget=StringWidget(label_msgid="label_nom",description_msgid="help_nom",i18n_domain="archbaty")
                       )

def prenom():
    return StringField('prenom',
                       required=  1 ,
                       searchable=1,
                       widget=StringWidget(label_msgid="label_prenom",description_msgid="help_prenom",i18n_domain="archbaty")
                       )

def heure_salarie():
    return FloatField('heure',
                       required=  1 ,
                       default = 8.0,
                       validators=('isFloatandPositive',),
                       widget=StringWidget(label_msgid="label_heure",
                                           size="2",
                                           macro="macro_left",
                                           description_msgid="help_prenom",
                                           i18n_domain="archbaty")
                       )



def adresse():
    return StringField('adresse',
                       required=0,
                       searchable=1 ,
                       default='',
                       
                       default_output_type='text/plain',
                       widget=TextAreaWidget(label_msgid="adresse ",
                                             rows=2,
                                             visible=0,
                                             description_msgid="help_adresse",
                                             i18n_domain='archbaty'))
def code_postal():
    return IntegerField('code_postal',
                        required=0 ,
                        searchable=1 ,
                        
                        validators='isZipCode',
                        widget=IntegerWidget(description_msgid='help_code_postal',
                                             maxlength=5,
                                             label_msgid='label_code_postal',
                                             i18n_domain='archbaty')
                        )


def order():
    return IntegerField('order',
                        required=0 ,
                        searchable=1 ,
                        default=0,
                        
                        widget=IntegerWidget(description_msgid='help_order',
                                             label_msgid='label_order',
                                             i18n_domain='archbaty')
                        )




def ville():
    return StringField('ville',
                       required=0,
                       searchable=1 ,
                       default='',
                       
                       widget=StringWidget(label_msgid="Ville",
                                           
                                           description_msgid="help_ville",
                                           i18n_domain='archbaty')
                       )


def telephone():
    return StringField('telephone',
                        required=0,
                        searchable=1 ,
                        validators='isFrenchPhoneNumber',
                  
                        widget=StringWidget(description_msgid='help_telephone',
                                             size=10,
                                             maxlength=10,
                                            i18n_domain='archbaty',
                                             label_msgid='Telephone'))
def portable():
    return StringField('portable',
                        required=0,
                        searchable=1 ,
                        validators='isMobileFrenchPhoneNumber',
                        widget=StringWidget(description_msgid='help_portable',
                                             size=10,
                                             maxlength=10,
                                             label_msgid='portable',
                                             i18n_domain='archbaty'))

def email():
    return StringField('email',
                       required=0,
                       searchable=1 ,
                       
                       validators=('isEmail',), 
                       widget=StringWidget(description_msgid='help_email',
                                           label_msgid='email',
                                           i18n_domain='archbaty'
                                           ))


    
    

def title():
    return StringField('title',
                       required=  1 ,
                       searchable=1,
                       accessor='Title',
                       widget=StringWidget(label="Identifiant",
                                           label_msgid="identifiant",
                                           description_msgid="help_identifiant",
                                           i18n_domain="archbaty")
                       )



def title_entreprise():
    return StringField('title',
                       required=1,
                       searchable=1,
                       accessor='Title',
                       widget =StringWidget(label_msgid="label_nom_entreprise",
                                            visible=1,
                                            description_msgid="help_nom_entreprise",
                                            i18n_domain="archbaty"
                                            
                                            ),
                       
                       )


def logo():
    return ImageField('logo',
                      schemata='Impression',
                      sizes={ 'logo' : (220,60),},
                      widget =ImageWidget(label_msgid="label_logo",
                                            visible=1,
                                            description_msgid="help_logo",
                                            i18n_domain="archbaty"
                                            
                                            ),
                      )


def print_footer():
    
    return StringField('print_footer',searchable=0,
                       schemata='Impression',
                       widget=TextAreaWidget(format=1,
                                             description='Pied de pages',
                                             label_msgid="pied_de_page",
                                             description_msgid="help_pied_de_page",
                                             label='Pied de page',
                                             i18n_domain="archbaty"))







def hidden_title():
    return StringField('title',
                       required=  0 ,
                       mode='',
                       accessor='Title',
                       )


def description():
    return StringField('description',searchable=1,
                       accessor='Description',
                       widget=TextAreaWidget(format=1,
                                             description='Rentrez la description',
                                             label_msgid="description",
                                             description_msgid="help_description",
                                             label='Description',
                                             i18n_domain="archbaty"))





def code_num():
    return IntegerField('code_num',
                       mode='rw',
                       searchable=1,
                       
                       default_method='getDefaultCodeNum', 
                       validators=('isUnique',),  
                       widget=StringWidget(
                                             label_msgid="code_num",
                                             description_msgid="help_code_num",
                                             i18n_domain="archbaty",
                                             macro="macro_left",
                                             size="10",
                                              ),
          
                       )


def code_affaire():
    return StringField('code_affaire',
                    mode='r',
                    accessor='getCode_affaire',
                    searchable=1,
                    widget=StringWidget(
                                 label_msgid="code_affaire",
                                 description_msgid="help_code_affaire",
                                 i18n_domain="archbaty",),



        
                     )

def ref_affaire():
    return ReferenceField('affaire',
                          mode='r',
                          required=1,
                          relationship='affaire',
                          vocabulary="getListAffaire",
                          allowed_types=('None',),
                          widget=ReferenceWidget(description='Code affaire', label='Code Affaire'),

                          )

def ref_article():
    return ReferenceField('article',
                          mode='rw',
                          required=1,
                          relationship='article',
                          vocabulary="getListArticle",
                          allowed_types=('None',),
                          widget=ReferenceWidget(description_msgid='help_code_article',
                                                 label_msgid='code_article',
                                                 i18n_domain="archbaty")
                          )


def ref_article_frais():
    return ReferenceField('article_frais',
                          mode='r',
                          
                          relationship='article_frais',
                          vocabulary="getListArticle",
                          allowed_types=('None',),
                          widget=ReferenceWidget(description_msgid='help_code_article', label_msgid='code_article', i18n_domain="archbaty")
                          )

def ref_article_credit():
    return ReferenceField('article_credit',
                          mode='r',
                          
                          relationship='article_credit',
                          vocabulary="getListArticle",
                          allowed_types=('None',),
                          widget=ReferenceWidget(description_msgid='help_code_article', label_msgid='code_article', i18n_domain="archbaty")
                          )



def code_exploitation():
    return StringField('code_exploitation',
                    mode='r',
                    accessor='getCode_exploitation',
                    searchable=1,
                    widget=StringWidget(
                                 label_msgid="code_exploitation",
                                 description_msgid="help_code_exploitation",
                                 i18n_domain="archbaty",),
        
                     )

def famille():
    return ReferenceField('famille',
                       vocabulary="getListFamille",
                       searchable=1,
                       required=  1,
                       mutator="setFamille",
                       edit_accesor="getFamille",
                       default_method='get_default_famille',
                       relationship='famille',
                       widget=ReferenceWidget(format="select",
                                              description='Veuillez selectionner la famille de cet article' ,
                                              label_msgid="famille",
                                              description_msgid="help_famille",
                                              label='Famille'),
          
                       )

def unite():
    return StringField('unite',
                       vocabulary="getListUnite",
                       allowed_types=('BatyUnite',),
                       default_method='get_default_unite',
                       edit_accesor='getUnite',
                       searchable=1,
                       required=  1 ,
                       
                     
                       widget=SelectionWidget(format="select",description_msgid='help_unite' ,label_msgid='unite', i18n_domain="archbaty"),
          
                       )


def tva():
    return StringField('tva',
                       vocabulary="getListTva",
	               
	               
	               
                       allowed_types=('',),
                       
                       required=  1 ,
                       
                     
                       widget=SelectionWidget(format="select",description_msgid='help_tva' ,label_msgid='tva', i18n_domain="archbaty"),
          
                       )



def ceofficient_value():
    return FixedPointField('coefficient',
                         required=1,
                         searchable=0,
                    )


def coefficient():
    return ReferenceField('coefficient',
                        vocabulary="getListCoefficient",
                        allowed_types=('BatyCoefficient',),
                        
                        searchable=1,
                        required=  1 ,

                        relationship='coefficient',
                        widget=ReferenceWidget(format="select",
                                               description_msgid='help_coefficient' ,
                                               label_msgdi='label_coefficient',
                                               i18n_domain='archbaty')
                          
          
                        )


def coefficient_stockage():
    return ReferenceField('coefficient_stockage',
                        vocabulary="getListCoefficientStockage",
                        allowed_types=('BatyCoefficientStockage',),
                        
                        searchable=0,
                        required=  1 ,

                        relationship='coefficient_stockage',
                        widget=ReferenceWidget(format="select",
                                               description_msgid='help_coefficient_stockage' ,
                                               label_msgdi='label_coefficient_stockage',
                                               i18n_domain='archbaty')
                          
          
                        )





def prix():
    return FloatField('prix',
                   searchable=1,
                   required=  1 ,
                   default=0.0,
                   validators=('isDecimal',),
                   mutator="setPrix",
                   widget=StringWidget(
                            size="10",
                            
                            description_msgid='description_prix',
                            label_msgid="prix",
                            macro="macro_euro",
                            i18n_domain="archbaty"
                            
                            ),
          
                   )



def prix_devis():
    return FloatField('prix',
                   searchable=1,
                   required=  1 ,
                   default=0.0,
                   validators=('isDecimal',),
                   default_method='getDefaultPrix',
                   mutator="setPrix",
                   widget=StringWidget(
                            size="10",
                            
                            description_msgid='description_prix_devis',
                            label_msgid="prix",
                            macro="macro_euro",
                            i18n_domain="archbaty"
                            
                            ),
          
                   )


def prix_total_devis():
    return ComputedField('prix',
                 
                         mode='r',  
                         default=0.0,
                         validators=('isDecimal',),
                         expression="""context.getPrix()""",
                         widget=DecimalWidget(
        size="10",
        description_msgid='help_prix_devis',
        label_msgid="prix_total",
        macro="macro_euro",
        i18n_domain="archbaty",
        ),
                         
                   
                   
                         )



def prix_moyen_ponderer():
    return FloatField('prix_moyen_ponderer',
                      mode='r',
                   
                   default=0.0,
                   validators=('isDecimal',),
                   
                   widget=DecimalWidget(
                            size="10",
                            description_msgid='prix_moyen_ponderer',
                            label_msgid="prix_moyen_ponderer",
                            macro="macro_euro"
                            ),
          
                   )



def dernier_prix_achat():
    return FloatField('dernier_prix_achat',
                      mode='r',
                   searchable=1,
                   default=0.0,
                   validators=('isDecimal',),
                   
                   widget=DecimalWidget(
                            size="10",
                            description_msgid='description_dernier_prix_achat',
                            label_msgid="dernier_prix_achat",
                            macro="macro_euro"
                            ),
          
                   )


def default_prix(label_msgid='prix',):
    return FloatField(label_msgid,
                      mode='rw',
                      default=0.0,
                      validators=('isDecimal',),
                   
                      widget=DecimalWidget(
                                          size="10",
                                          description_msgid='help_%s' % (label_msgid,),
                                          label_msgid=label_msgid,
                                          macro="macro_euro",
                                          i18n_domain="archbaty",
                                          ),
          
                      )
                      
def prix_tache():
    return FloatField(prix,
                      mode='rw',
                      default=0.0,
                      validators=('isDecimal',),
                   
                      widget=DecimalWidget(
                                          size="10",
                                          description_msgid='help_%s' % ('prix_tache',),
                                          label_msgid='label_prix_tache',
                                          macro="macro_euro",
                                          i18n_domain="archbaty",
                                          ),
          
                      )

def prix_vente():
    return ComputedField('prix_vente',
                      mode='r',

                   default=0.0,
                   validators=('isDecimal',),
                   expression="""(1.0+context.coefficient_value()/100.0)*context.prix""",
                   widget=DecimalWidget(
                            size="10",
                            description_msgid='help_prix_vente',
                            label_msgid="prix_vente",
                            macro="macro_euro",
                            i18n_domain="archbaty",
                            ),
          
                   )


def affaire_prix_vente():
    return FloatField('prix_vente',
                      mode='r',
                      default=0.0,
                      widget=DecimalWidget(
                                              label_msgid="affaire_prix_vente",
                                              description_msgid="help_affaire_prix_vente",
                                              i18n_domain="archbaty",
                                              macro="macro_euro"
                                              )
                              
                       )

 

def code_comptable():
    return StringField('code_comptable',
                       searchable=1,
                       required=1,
                       vocabulary="getListCodeComptable",
                       widget=SelectionWidget(
                                              label_msgid="code_comptable",
                                              description_msgid="help_code_comptable",
                                              i18n_domain="archbaty"
                                              )
                              
                       )

def en_stock():
    return BooleanField('stock',
                      
                        widget= BooleanWidget(label="En Stock",
                                              description="Tenu en stock (O/N)"),                  
                        )

def seuil_stock():
    return FloatField('seuil_stock',
                      default=0.0,
                      validators=('isFloatandPositive',),
                      widget= StringWidget(label_msgid="seuil_stock",
                                           macro="macro_left",
                                           size="10",
                                           description_msgid="help_seuil_stock"),
               
                      )


def temps_moyen_appro():
    return FloatField('temps_moyen_appro',
                      validators=('isFloatandPositive',),
                      default=0,
                      
                      widget= StringWidget(label="Temps moyen d\'approvisionnement",description="Temps moyen d\'approvisionnement (en jour)",macro='macro_jour', size='10'),
                      
                      )

def quantite():
    return FloatField('quantite',
                      default=0.0,
                      mutator="setQuantite",

                      validators=('isFloatandPositive',),
                      visible=1,
                      widget= StringWidget(label_msgid="quantite_en_stock",
                                           description_msgid="help_quantite_en_stock",
                                           i18n_domain='archbaty',
                                           size="10",
                                           macro="macro_left"),
                      
                      )



 
def quantite_theorique():
    return FloatField('quantite_theorique',
                      default=0.0,
                      mode='r',
                      widget= StringWidget(label_msgid="quantite_reel_en_stock",
                                           description_msgid="help_quantite_reel_en_stock",
                                           i18n_domain='archbaty',),
                      
                    )

                      
def pj():
    return FileField('pj',
                     required=0,
                     searchable=1,
                     widget=FileWidget(label_msgid="label_filepj",
                                       description_msgid="help_filepj",
                                       i18n_domain="archbaty",
                                       ),
                     )

def quantite_entre_mois_pair():
    return FloatField('quantite_entre_mois_pair',
                       default=0.0,
                       mode='r',
                       widget=StringWidget(
                                           label_msgid="quantite_entre_mois_pair",
                                           macro="macro_left",
                                           description_msgid="help_quantite_entre_mois_pair",
                                           i18n_domain="archbaty")
                      )


def field_quantite(id):
    return FloatField(id,
                      default=0.0,
                      mode='r',
                      validators=('isFloatandPositive',),
                      widget=StringWidget(
                                          label_msgid='label_'+id,
                                          macro="macro_left",
                                          description_msgid="help_"+id,
                                          i18n_domain="archbaty")
                      )


def field_mouvement(id):
    return FloatField(id,
                       default=0.0,
                       mode='r',
                       widget=StringWidget(
                                           label_msgid="label_"+id,
                                           macro="macro_left",
                                           description_msgid="help_"+id,
                                           i18n_domain="archbaty")
                      )

def field_float(id,default=0.0):
    return FloatField(id,
                       default=default,
                       mode='rw',
                       required=1,
                       widget=StringWidget(
                                           label_msgid="label_"+id,
                                           size="8",
                                           macro="macro_left",
                                           description_msgid="help_"+id,
                                           i18n_domain="archbaty")
                      )

def coefficient_vente(  ):
    id='coefficient_vente'
    return FloatField(id,
                      default=0.0,
                      mutator="setCoefficient_vente",	     
                      widget=StringWidget(
                                           label_msgid="label_" + id,
                                           macro="macro_left",
                                           size="5",
                                           description_msgid="help_"+id,
                                           i18n_domain="archbaty")
                      )


def coefficient_marge(  ):
    id='coefficient_marge' 
    
	
    return FloatField(id,
                       default=0.0,
                       mode='r',                   
                       widget=StringWidget(
                                           label_msgid="label_" + id,
                                           macro="macro_left",
                                           size="5",
                                           description_msgid="help_"+id,
                                           i18n_domain="archbaty")
                      )


def description_commercial(  ):
    id='description'
    return StringField(id,
                       default=0.0,
                       searchable=1,
                       accessor='Description',
                       
                       widget=TextAreaWidget(format=1,
                                           label_msgid="label_description_commercial",
                                           
                                           description_msgid="help_description_commercial",
                                           i18n_domain="archbaty")
                      )
    

def field_string(id):
    return StringField(id,
                       default=0.0,
                       mode='r',
                       widget=StringWidget(
                                           label_msgid="label_"+id,
                                           
                                           description_msgid="help_"+id,
                                           i18n_domain="archbaty")
                      )




def quantite_entre_mois_impair():
    return FloatField('quantite_entre_mois_impair',
                       default=0.0,
                       mode='r',
                       widget=StringWidget(
                                           label_msgid="quantite_entre_mois_impair",
                                           description_msgid="help_quantite_entre_mois_impair",
                                           i18n_domain="archbaty")
                      )

def quantite_entre_exercice():
    return FloatField('quantite_entre_exercice',
                       default=0.0,
                       mode='r',
                       widget=StringWidget(
                                           label_msgid="quantite_entre_exercice",
                                           description_msgid="help_quantite_entre_exercice",
                                           i18n_domain="archbaty")
                      )

def quantite_sorti_mois_pair():
    return FloatField('quantite_sorti_mois_pair',
                       default=0.0,
                       mode='r',
                       widget=StringWidget(
                                           label_msgid="quantite_sorti_mois_pair",
                                           description_msgid="help_quantite_sorti_mois_pair",
                                           i18n_domain="archbaty")
                      )

def quantite_sorti_mois_impair():
    return FloatField('quantite_sorti_mois_impair',
                       default=0.0,
                       mode='r',
                       widget=StringWidget(
                                           label_msgid="quantite_sorti_mois_impair",
                                           description_msgid="help_quantite_sorti_mois_impair",
                                           i18n_domain="archbaty")
                      )

def quantite_sorti_exercice():
    return FloatField('quantite_sorti_exercice',
                       default=0.0,
                       mode='r',
                       widget=StringWidget(
                                           label_msgid="quantite_sorti_exercice",
                                           description_msgid="help_quantite_sorti_exercice",
                                           i18n_domain="archbaty")
                      )


def pdf_file():
    return FileField('pdf_file',default_content_type='application/pdf',accessor='getPdf_file')
                     
def ref_client():
    return ReferenceField('client',
                          required=1,
                          vocabulary="getListClient",
                          allowed_types=('None',),
                          relationship='client',
                          widget=ReferenceWidget(format="select",description_msgid='help_client' ,label_msgid='client',i18n_domain="archbaty",macro="macro_client"))

def ref_secteur():
    return ReferenceField('secteur',
                          required=1,
                          vocabulary="getListSecteur",
                          allowed_types=('None',),
                          relationship='secteur',
                          widget=ReferenceWidget(format="select",description_msgid='help_secteur' ,label_msgid='secteur',i18n_domain="archbaty" ,macro="macro_secteur"))




def quantite_prevu():
    return FloatField('quantite_prevu',
                      mode='r',
                      default=0.0,
                      widget=DecimalWidget(
                              size="7",
                              description_msgid='help_quantite_prevu',
                              label_msgid="label_quantite_prevu",
                              i18n_domain="archbaty",
                              
                            ),
                      )

def prix_prevu():
    return FloatField('prix_prevu',
                         mode='r',
                         default=0.0,
                         widget=DecimalWidget(
                              size="10",
                              description_msgid='help_prix_prevu',
                              label_msgid="label_prix_prevu",
                              i18n_domain="archbaty",
                              macro="macro_euro"
                            ),
                         )


def quantite_tache():
    return FloatField('quantite',
                      default=1.0,
                  

                      validators=('isFloatandPositive',),
                      
                      widget= StringWidget(label_msgid="quantite",
                                         description_msgid="quantite_tache",
					 i18n_domain='archbaty',
                                           size="10",
                                           macro="macro_left"),
                      
                     )

def quantite_prime():
    return FloatField('quantite',
                      default=1.0,
                  

                      validators=('isFloatandPositive',),
                      
                      widget= StringWidget(label_msgid="quantite",
                                         description_msgid="quantite_prime",
					 i18n_domain='archbaty',
                                           size="10",
                                           macro="macro_left"),
                      
                     )



def prix_tache():
    return FloatField('prix',
                      default=0.0,
                  

                      validators=('isFloatandPositive',),
                      
                      widget= StringWidget(label_msgid="prix",
                                         description_msgid="prix_tache",
					 i18n_domain='archbaty',
                                           size="10",
                                           macro="macro_left"),
                      
                     )


def prix_prime():
    return FloatField('prix',
                      default=0.0,
                  

                      validators=('isFloatandPositive',),
                      
                      widget= StringWidget(label_msgid="prix",
                                         description_msgid="prix_prime",
					 i18n_domain='archbaty',
                                           size="10",
                                           macro="macro_left"),
                      
                     )



def reference_affaire():

	return ReferenceField('affaire',
 #                      write_permission=BatyPermissions.EDIT_BATY_JOURNAL,
                       required=1,
                       relationship='affaire',
                       validators='validStock',
                       vocabulary="getListAffaire",
                       allowed_types=('None',),
        
                       
                       widget=ReferenceWidget(description_msgid='help_code_affaire', 
		       			      label='label_code_affaire',
					      i18n_domain='archbaty',
					      #macro="macro_affaire"
					      ),

                    	)
		    
         
         
def reference_tache():
        return ReferenceField('tache',
  #                     write_permission=BatyPermissions.EDIT_BATY_JOURNAL,
                       required=  1 ,
                       searchable=1,
                       relationship='tache',
                       vocabulary='getListTache',
                       allowed_types=('None',),
                       
                       
                       
                       
                       widget=ReferenceWidget(
		       			description_msgid='help_tache' ,
					label_msgid='label_tache',
					i18n_domain='archbaty',
					#macro="macro_tache",
					),

                       )


def reference_prime():
        return ReferenceField('prime',
  #                     write_permission=BatyPermissions.EDIT_BATY_JOURNAL,
                       required=  1 ,
                       searchable=1,
                       relationship='prime',
                       vocabulary='getListPrime',
                       allowed_types=('None',),
                       
                       
                       
                       
                       widget=ReferenceWidget(
		       			description_msgid='help_prime' ,
					label_msgid='label_prime',
					i18n_domain='archbaty',
					#macro="macro_tache",
					),

                       )




def date_journal():
	return DateTimeField('date',
			required=1,
			default=DateTime(),
                        searchable=1,
			widget=CalendarWidget(
		#			format='%d%m%Y',
		       			description_msgid='help_date_journal' ,
					label_msgid='label_date_journal',
					i18n_domain='archbaty',
			#		macro="macro_salarie",
					
					),

                       )
        

def reference_salarie():
        return ReferenceField('salarie',
  #                     write_permission=BatyPermissions.EDIT_BATY_JOURNAL,
                       required=  1 ,
                       searchable=1,
                       relationship='salarie',
                       vocabulary='getListSalarie',
                       allowed_types=('None',),
                       #edit_accessor='get_last_salarie',
                       
                       
                       
                       widget=ReferenceWidget(
		       			description_msgid='help_salarie' ,
					label_msgid='label_salarie',
					i18n_domain='archbaty',
			#		macro="macro_salarie",
					
					),

                       )
        
