from AccessControl.SecurityManagement import newSecurityManager
from AccessControl.SecurityManagement import noSecurityManager
from Acquisition import aq_base
from Interface import *
from time import time
import os
os.environ['EVENT_LOG_FILE'] = os.path.join(os.getcwd(), 'zLOG.log')
print os.getcwd()
os.environ['EVENT_LOG_SEVERITY'] = '-300'
from Testing import ZopeTestCase 
ZopeTestCase.installProduct('PageTemplates')
ZopeTestCase.installProduct('CMFCore')
ZopeTestCase.installProduct('CMFDefault')
ZopeTestCase.installProduct('CMFCalendar')
ZopeTestCase.installProduct('CMFTopic')
ZopeTestCase.installProduct('DCWorkflow')
ZopeTestCase.installProduct('CMFActionIcons')
ZopeTestCase.installProduct('CMFQuickInstallerTool')
ZopeTestCase.installProduct('CMFFormController')
#ZopeTestCase.installProduct('Formulator')
ZopeTestCase.installProduct('GroupUserFolder')
ZopeTestCase.installProduct('ZCTextIndex')
ZopeTestCase.installProduct('CMFPlone')
ZopeTestCase.installProduct('MailHost', quiet=0)

ZopeTestCase.installProduct('PythonScripts', quiet=0)
ZopeTestCase.installProduct('ExternalMethod', quiet=0)
ZopeTestCase.installProduct('Archetypes', 0)
ZopeTestCase.installProduct('StandardCacheManagers', 0)
ZopeTestCase.installProduct('ZCatalog')
ZopeTestCase.installProduct('PortalTransforms', 0)
ZopeTestCase.installProduct('RMLPageTemplate', 0)
ZopeTestCase.installProduct('ArchBaty',0)


from Products.CMFPlone.tests import PloneTestCase

from Products.ArchBaty.baty_types.BatyArticle import BatyArticle
from Products.ArchBaty.baty_types.BatyAffaire import BatyAffaire
from Products.ArchBaty.baty_types.BatyJournal import BatyBaseJournal, BatyJournal, BatyJournalLigne, BatyJournalHeure, BatyJournalHeureLigne
from DateTime import DateTime

class BatyTestCase (PloneTestCase.PloneTestCase):

    def afterSetUp(self):
        pass

    
        

    def getManagerUser(self):
        uf = self.portal.acl_users
        return uf.getUserById('PloneManager').__of__(uf)

    def getMemberUser(self):
        uf = self.portal.acl_users
        return uf.getUserById('PloneMember').__of__(uf)

    def getEntreprise(self):
        return self.portal.Entreprises.test_baty

    def createDefaultArticle(self):
        entreprise=self.portal.Entreprises.test_baty
        base_article=self.portal.Entreprises.test_baty.getDestination('BatyArticle')
        base_article._setObject('article1',BatyArticle('article1'))

        
        
        kw={'famille':entreprise.getFirstObjectForType('BatyFamille').UID(),'unite':'litre','coefficient':entreprise.getFirstObjectForType('BatyCoefficient').UID(),'prix':1.0,'code_comptable':4,'stock':1,'quantite':54.0}
        base_article.article1.update(**kw)
        return base_article.article1


    
   #  def login(self,user_id):
#         uf = self.portal.acl_users
#         user=uf.getUserById(user_id).__of__(uf)
#         newSecurityManager(None, user)

#     def logout(self):
#         noSecurityManager()




    def top(self):
        return time()

    def end(self,start):
        return "done (%.3f)\n" % (time() - start)

    def log(self,arg):
        file=open('out.log','a')
        
        file.write(arg)
        file.close()



    def create_setUpJournal(self):
        self.login('PloneManager')
        get_transaction().begin()
        ## creation article ###
        entreprise=self.getEntreprise()
        
        base_article=entreprise.getDestination('BatyArticle')
        base_article.invokeFactory(id='article1',type_name='BatyArticle')
        base_article.invokeFactory(id='article2',type_name='BatyArticle')

        article1=base_article.article1
        article2=base_article.article2

        kw={'famille':entreprise.Configuration.mat.UID(),'unite':'kg','prix':1.0,'stock':1,'quantite':54.0}
        base_article.article1.update(**kw)
        base_article.article2.update(**kw)

        

        
        ## creation client ##
        entreprise.getDestination('BatyClient').invokeFactory(id='client1',type_name='BatyClient')
        ## creation affaire ##
        entreprise.getDestination('BatyAffaire').invokeFactory(id='affaire1',type_name='BatyAffaire')
        affaire=entreprise.getDestination('BatyAffaire').affaire1
        ## creation tache et prime ##
        base=entreprise.getDestination('BatyTache')
        base.invokeFactory(id='tache1',type_name='BatyTache')
        base.invokeFactory(id='prime1',type_name='BatyPrime')

        kw={'prix':10,'famille':'mdo'}
        

        
        tache=base.tache1
        prime=base.prime1
        
        prime.update(**kw)
        tache.update(**kw)

        ## creation salarie ###
        base=entreprise.getDestination('BatySalarie')
        base.invokeFactory(id='salarie0',type_name='BatySalarie')
        salarie=base.salarie0
        
        

        
        ## creation journal ##
        #self.createMemberarea('PloneManager')
        #membership = self.portal.portal_membership
        #folder=membership.getHomeFolder('PloneManager')
        folder=self.getEntreprise().getDestination('BatyJournal')
        
        
        folder._setObject('journal_m',BatyJournal('journal_m'))
        journal_m=folder.journal_m
        pds=entreprise.getPeriodes()

        # on a une display list
        
        kw={'periode':str(pds[0]),'entreprise':entreprise.UID(),'date_de_saisie':DateTime()}
        journal_m.update(**kw)
        
        
        journal_m.invokeFactory(id="matiere1", type_name='BatyJournalLigne')

        kw={
            'affaire':affaire.UID(),
            'article':article1.UID(),
            'stock':1,
            'quantite':10,
            'prix_unitaire':1
            }


        journal_m['matiere1'].update(**kw)
        ## journal des heures

        folder._setObject('journal_h',BatyJournalHeure('journal_h'))
        
        journal_h=folder.journal_h
        kw={'periode':str(pds[0]),'date_de_saisie':DateTime()}
        journal_h.update(**kw)
        
        ### creation des lignes au niveau du journal


        journal_h._setObject('heure1',BatyJournalHeureLigne('heure1'))

        journalHeureLigne=journal_h['heure1']

        kw={'salarie':salarie.UID(),
            'affaire':affaire.UID(),
            'quantite':10,
            'tache':tache.UID(),
            }
        journalHeureLigne.update(**kw)

        journal_h._setObject('heure2',BatyJournalHeureLigne('heure2'))

        journalHeureLigne=journal_h['heure2']
        
        kw={'salarie':salarie.UID(),
            'affaire':affaire.UID(),
            'quantite':10,
            'tache':prime.UID(),
            }
        journalHeureLigne.update(**kw)
        
        ## on cree un devis + une section, un produit et une ligne pour les articles, une ligne pour les heures

        base=self.getEntreprise().getDestination('BatyDevis')
        base.invokeFactory(type_name='BatyDevis',id='devis')
        base.devis.invokeFactory(type_name='BatySection',id='section1')
        kw={'coefficient_vente':10.0,'coefficient_marge':0.0,'client':'client1','tva':'tva5'}
        base.devis.update(**kw)
        base.devis.section1.invokeFactory(type_name='BatyProduit',id='produit1')
        base.devis.section1.produit1.invokeFactory(type_name='BatyLigneProduit',id='ligneDevis1')
        base.devis.section1.produit1.invokeFactory(type_name='BatyLigneProduitHeure',id='heureDevis1')

        kw={'article':article1.UID(),'quantite':10.0,'unite':'me2'}
        base.devis.section1.produit1.ligneDevis1.update(**kw)
        kw={'tache':tache.UID(),'quantite':10.0,'unite':'heu'}
        base.devis.section1.produit1.heureDevis1.update(**kw)


        ## nouveau produit
        base.devis.section1.invokeFactory(type_name='BatyProduit',id='produit2')
        base.devis.section1.produit2.invokeFactory(type_name='BatyLigneProduit',id='ligneDevis1')
        base.devis.section1.produit2.invokeFactory(type_name='BatyLigneProduitHeure',id='heureDevis1')

        base.devis.section1.produit2.update(**{'quantite':10.0,'tva':'tva19'})
        
        kw={'article':article1.UID(),'quantite':10.0,'unite':'me2'}
        base.devis.section1.produit2.ligneDevis1.update(**kw)
        kw={'tache':tache.UID(),'quantite':10.0,'unite':'heu'}
        base.devis.section1.produit2.heureDevis1.update(**kw)
        
        
        

        return  {
            'article1':article1,
            'article2':article2,
            'affaire':affaire,
            'salarie':salarie,
            'tache':tache,
            'prime':prime,
            'journal_m':journal_m,
            'ligne1_m':journal_m['matiere1'],
            'journal_h':journal_h,
            'ligne1_h':journal_h['heure1'],
            'ligne2_h':journal_h['heure2'],
            'ligneDevis1':base.devis.section1.produit1.ligneDevis1,
            'heureDevis1':base.devis.section1.produit1.heureDevis1,
            
            }

    
    
        


def setupArchBaty(app, quiet=0):
    get_transaction().begin()
    _start = time()
    uf = app.portal.acl_users

    if not quiet: ZopeTestCase._print('Adding ArchBaty ... ')
    uf = app.portal.acl_users
    uf._doAddUser('PloneMember', '', ['Members'], [])
    uf._doAddUser('PloneManager', '', ['Manager'], [])
    # login as manager
    user = uf.getUserById('PloneManager').__of__(uf)
    
    newSecurityManager(None, user)
    qi = app.portal.portal_quickinstaller
    #try:
    qi.installProduct('Archetypes')
        
    #except Exception, e:
    #    pass
    #try:
    qi.installProduct('ArchBaty')
    #except Exception, e:
    #    pass
    
    uf._doAddUser('BatyManager','',['Baty manager','Members'],[])
    uf._doAddUser('BatySecretaire','',['Baty secretaire','Members'],[])

    
    
    app.portal.Entreprises.createObject(id='test_baty',type_name='BatyEntreprise')

    
    
        
    
    
    
    noSecurityManager()
    get_transaction().commit()
    if not quiet:
        ZopeTestCase._print('done (%.3fs)\n' % (time()-_start,))
## for simulate a request wrapper    
import Zope
#app = ZopeTestCase.app()
from Testing import makerequest
app=makerequest.makerequest(Zope.app())

setupArchBaty(app)


ZopeTestCase.close(app)
