#
# Skeleton PloneTestCase
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
#from Products.CMFPlone.tests import PloneTestCase
from Products.ArchBaty.tests import BatyTestCase

class TestSomeProduct(BatyTestCase.BatyTestCase):

    
        

    def testFolderEntreprise(self):
        
        self.failUnless(hasattr(self.portal,'Entreprises'))

    
        

    def testgetUidFromId(self):
        entreprise=self.getEntreprise()
        #print entreprise
        res1=entreprise.getUidFromId('smat')
        res2=entreprise.getUidFromId('smat',entreprise.Configuration)
        self.failUnless(res1 is not None and  res2 is not None)

    def testaddAffaire(self):
        self.login('PloneManager')
        entreprise=self.getEntreprise()
        affaire=entreprise.getDestination('BatyAffaire')
        affaire.invokeFactory(id='test_affaire',type_name='BatyAffaire')
        #print entreprise.getListAffaire()
        #self.failUnless(entreprise.archetype_tool.getObject(entreprise.getListAffaire()[0] is None))
        #self.failUnless(entreprise.archetype_tool.getObject(entreprise.getListAffaire()[1] is None))

        
    def test_setup_property(self):
        self.login('PloneManager')
        base=self.portal.objectValues(['BatyBaseEntreprise'])[0]

        self.failUnless(base.getProperty('right_slots') is not None and base.getProperty('left_slots') is not None)
        
        #print "right slot ---" + str(base.getProperty('right_slots'))
        #print "left slot ---"  + str(base.getProperty('left_slots'))

    def testaddTache(self):
        self.login('PloneManager')
        entreprise=self.getEntreprise()
        tache=entreprise.getDestination('BatyTache')
        tache.invokeFactory(id='test_tache',type_name='BatyTache')


    def testTitleBaseJournal(self):
        entreprise=self.getEntreprise()
        base_journal=entreprise.getDestination('BatyJournal')

        self.failUnless(base_journal.Title()=='Base Journal')
    
    def testAddJournal(self):
        #user=self.getManagerUser()
        #newSecurityManager(None,user)*
        t=self.top()
        self.login('PloneManager')
        #self.portal.Entreprises.createObject(id='test_baty',type_name='BatyEntreprise')
        from DateTime import DateTime
        self.getEntreprise().getDestination("BatyJournal").invokeFactory(id='test journal',type_name="BatyJournal",title="journal du %02d/%02d/%04d" % (DateTime().day(),DateTime().month(),DateTime().year()))
        
        result=self.portal.portal_catalog.searchResults({'Type':('BatyJournal',)})


    def testAddArticle(self):
        self.login('PloneManager')
        entreprise=self.getEntreprise()
        base_article=entreprise.getDestination('BatyArticle')
        base_article.invokeFactory(id='article1',type_name='BatyArticle')
        #print 'article :' ,entreprise.getListArticle()
        
        kw={'famille':entreprise.getFirstObjectForType('BatyFamille').UID(),'unite':'litre','prix':1.0,'code_comptable':4,'stock':1,'quantite':54.0}

        base_article.article1.update(**kw)
        self.failUnless(base_article.article1.getCoefficient() is not None)
        self.failUnless(base_article.article1.getCoefficientObject() is not None)
        self.failUnless(base_article.article1.getCoefficientObject().getArticleFraisObject() is not None and base_article.article1.getCoefficientObject().getArticleCreditObject() is not None )
        self.failUnless(base_article.article1.getArticleFraisObject() is not None)
        self.failUnless(base_article.article1.getArticleCreditObject() is not None)
        

    def testCatalog(self):
        self.login('PloneManager')
        entreprise=self.getEntreprise()
        query=entreprise.makeQuery(type=('BatyFamille'))
        catalog= entreprise.portal_catalog
        results=catalog(query)
        
        [x.getObject().UID() for x in results]
        
        query=entreprise.makeQuery(type=('BatyCoefficient'))
        catalog= entreprise.portal_catalog
        results=catalog(query)
        #print [x.UID for x in results]
        [x.getObject().UID() for x in results]

        query=entreprise.makeQuery(type=('BatyData'))
        
        catalog= entreprise.portal_catalog
        results=catalog(query)
                
        [x.getObject().UID() for x in results]

    
        
    def testFamille(self):
        self.login('PloneManager')
        entreprise=self.getEntreprise()
        
        for item in entreprise.Configuration.objectValues('BatyFamille'):
            ## ajout niveau 1 ##
            self.failUnless(item.getObjectFromAttr('coefficient') is not None)
            self.failUnless(item.getObjectFromAttr('coefficient_stockage') is not None)
            
            item.invokeFactory(id='sous_famille'+item.id,title='sous_famille'+ str(item.title_or_id()),type_name='BatyFamille')
        #print "---------- test famille ------------"
        #print entreprise.getListFamille()
        
    

    def testPages(self):
        self.login('PloneManager')
        self.portal.init_request()
        #print self.portal.REQUEST
        self.portal.index_html()
        
        self.portal.Entreprises.test_baty.batyentreprise_custom_view()

    def test_create_coefficient(self):
        self.login('PloneManager')
        conf=self.getEntreprise().Configuration
        conf.invokeFactory(id='coef_test',title='coef_test',type_name="BatyCoefficient")
        for item in self.getEntreprise().Configuration.objectValues('BatyCoefficient'):
            self.failUnless(item.getArticleFraisObject() is not None)
            #print item.getArticleFraisObject()
            self.failUnless(item.getArticleCreditObject() is not None)
            #print item.getArticleCreditObject()


    def test_create_coefficient_stockage(self):
        self.login('PloneManager')
        conf=self.getEntreprise().Configuration
        conf.invokeFactory(id='coef_test',title='coef_test',type_name="BatyCoefficientStockage")
        for item in self.getEntreprise().Configuration.objectValues('BatyCoefficientStockage'):
            self.failUnless(item.getArticleFraisObject() is not None)
            #print item.getArticleFraisObject()
            self.failUnless(item.getArticleCreditObject() is not None)
            #print item.getArticleCreditObject()
    
            
        
        
        

    def test_create_secteur(self):
        self.login('PloneManager')
        entreprise=self.getEntreprise()
        entreprise.init_request()
        entreprise.Configuration.batysecteur_configure()
        entreprise.Configuration.invokeFactory(id='test_secteur',title="test",description="ceci est un test",type_name="BatySecteur")

    def test_get_default_heure(self):
        self.login('PloneManager')
        entreprise=self.getEntreprise()
        entreprise.baty_tool.get_property('default','heure_salarie_default')
        
    def test_list_element_from_uid(self):
        self.login('PloneManager')
        
        list_famille=self.portal.baty_tool.listElementFromUid('Configuration',filter={'portal_type':'BatyFamille'})
        #print len(list_famille)


    def test_transform_text_for_rml(self):
        text=self.portal.transform_text_for_rml('ceci est un text a coupe de longueur dix',10,1)
        self.failUnless([i for i in text.split('\n') if len(i)>10] is not None)
        text=self.portal.transform_text_for_rml('ceci hhhf hsjfhsjfd sjdfhsjfdh sjfdhsfd sjfdhsjfh jghfsjfd djfhjfd sjdfhdjf sjdfhfd sdfhjsfd sdfhsjfd skfhkf skfhsdf ksdfhkdsf ksdfnsdf est un text a coupe de longueur 20',20,1)
        self.failUnless([i for i in text.split('\n') if len(i)>20] is not None)
        text= self.portal.transform_text_for_rml('ceci hhhf hsjfhsjfd sjdfhsjfdh sjfdhsfd sjfdhsjfh jghfsjfd djfhjfd sjdfhdjf sjdfhfd sdfhjsfd sdfhsjfd skfhkf skfhsdf ksdfhkdsf ksdfnsdf est un text a coupe de longueur 40',40,1)
        self.failUnless([i for i in text.split('\n') if len(i)>40] is not None)
        text= self.portal.transform_text_for_rml('avec un long mot vvvvvvvvvvvvvvvvvvv',15,1)
        self.failUnless([i for i in text.split('\n') if len(i)>15] is not None)

if __name__ == '__main__':
    framework()
else:
    # While framework.py provides its own test_suite()
    # method the testrunner utility does not.
    def test_suite():
        from unittest import TestSuite, makeSuite
        suite = TestSuite()
        suite.addTest(makeSuite(TestSomeProduct))
        return suite
