#
# Skeleton PloneTestCase
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
#from Products.CMFPlone.tests import PloneTestCase
from Products.ArchBaty.tests import BatyTestCase
from Products.ArchBaty.baty_types.BatyArticle import BatyArticle
from Products.ArchBaty.baty_types.BatyAffaire import BatyAffaire
from Products.ArchBaty.baty_types.BatyJournal import BatyBaseJournal, BatyJournalHeure, BatyJournalHeureLigne
from DateTime import DateTime
from Acquisition import aq_self


class TestWorkflowJournal( BatyTestCase.BatyTestCase):

    def create_SetUp(self):
        t=self.top()
        self.login('PloneManager')
        get_transaction().begin()
        ## creation article ###
        entreprise=self.getEntreprise()
        
        base=entreprise.getDestination('BatyTache')
        base.invokeFactory(id='tache1',type_name='BatyTache')
        base.invokeFactory(id='prime1',type_name='BatyPrime')

        kw={'prix':10,'famille':entreprise.getFirstObjectForType('BatyFamille').UID()}
        

        
        tache1=base.tache1
        prime1=base.prime1
        
        base.prime1.update(**kw)
        kw={'famille':entreprise.getFirstObjectForType('BatyFamille').UID()}
        base.tache1.update(**kw)
        ## creation salarie ###
        base=entreprise.getDestination('BatySalarie')
        base.invokeFactory(id='salarie0',type_name='BatySalarie')
        salarie=base.salarie0
        
        ## creation client ##
        entreprise.getDestination('BatyClient').invokeFactory(id='client1',type_name='BatyClient')
        ## creation affaire ##
        entreprise.getDestination('BatyAffaire').invokeFactory(id='affaire1',type_name='BatyAffaire')
        affaire1=entreprise.getDestination('BatyAffaire').affaire1

            
        
        ## creation journal ##
        folder=entreprise.getDestination('BatyJournal')
        
        
        folder._setObject('journal_heure',BatyJournalHeure('journal_heure'))
        
        journal=folder.journal_heure
        kw={'periode':'12-2004','date_de_saisie':DateTime()}
        journal.update(**kw)


        return {
            'salarie':salarie,
            'affaire':affaire1,
            'tache':tache1,
            'prime':prime1,
            'journal':journal
            }
    
     
        
    def test_getcoefficient(self):
        """ teste la recuperation de la valeur d'un coefficient d'une tache ou d'une prime """
        conf=self.create_SetUp()
        self.login('PloneManager')
        tache=conf['tache']
        prime=conf['prime']
        print "coefficient de tache ",tache.getCoefficientValue()
        print "coefficient de prime ",prime.getCoefficientValue()
        

    def test_mvt(self):
        """ teste le mouvement d'une ligne de journal """
        
      
        conf=self.create_SetUp()
        self.login('PloneManager')
        journalHeure=conf['journal']
        #journalHeure.invokeFactory(id='heure1',type_name='BatyJounalHeureLigne')

        journalHeure._setObject('heure1',BatyJournalHeureLigne('heure1'))

        journalHeureLigne=journalHeure['heure1']

        kw={'salarie':conf['salarie'].UID(),
            'affaire':conf['affaire'].UID(),
            'quantite':10,
            'tache':conf['tache'].UID(),
            }
        #map(lambda x : setattr(journalHeureLigne,x,kw[x]),kw.keys())
        journalHeureLigne.update(**kw)
        print "------ mouvement de 10 de la tache tache1 ---------"
        self.portal.baty_tool.mvt_journal_heure_ligne(journalHeureLigne,create=1)
        ### test de la validite des resultat
        periode=journalHeure.get_periode_type()
        #self.failUnless(periode!='pair')
        list=conf['affaire'].getMouvementByFamille()
        obj=list[0][1]
        print "OBJ",str(obj),obj.getQuantite_mois_pair()
        print "PERIODE",journalHeure.get_periode_type()
        self.failUnless(periode=='pair')
        
        
        print obj,'getQuantite_mois_pair',obj.getQuantite_mois_pair()
        
        print conf['salarie'],'getHeure_pair',conf['salarie'].getHeure_pair()
        print conf['tache'],'getQuantite_entre_mois_pair',conf['tache'].getQuantite_entre_mois_pair()
        

        print "------ suppression de 10 de la tache tache1 ---------"
        self.portal.baty_tool.mvt_journal_heure_ligne(journalHeureLigne,create=0)

        list=conf['affaire'].getMouvementByFamille()
        obj=list[0][1]
        print obj,'getQuantite_mois_pair',obj.getQuantite_mois_pair()
        print conf['salarie'],'getHeure_pair',conf['salarie'].getHeure_pair()
        print conf['tache'],'getQuantite_entre_mois_pair',conf['tache'].getQuantite_entre_mois_pair()
        self.failUnless(obj.getQuantite_mois_pair()==0)
        self.failUnless(conf['salarie'].getHeure_pair()==0)
        self.failUnless(conf['tache'].getQuantite_entre_mois_pair()==0)
        
    def test_prime(self):
        conf=self.create_SetUp()
        self.login('PloneManager')
        journalHeure=conf['journal']

        journalHeure._setObject('heure1',BatyJournalHeureLigne('heure1'))
        journalHeurePrime=journalHeure['heure1']

        kw={'salarie':conf['salarie'].UID(),
            'affaire':conf['affaire'].UID(),
            'quantite':10,
            'tache':conf['prime'].UID(),
            }


        
        journalHeurePrime.update(**kw)
        print "-------------- CREATION ---------------"
        print "------ mouvement de 10 de la prime prime1 ---------"
        self.portal.baty_tool.mvt_journal_heure_ligne(journalHeurePrime,create=1)
        list=conf['affaire'].getMouvementByFamille()
        obj=list[0][1]
        print " init "
        print obj,'getQuantite_mois_pair',obj.getQuantite_mois_pair()
        print obj,'getPrix_mois_pair',obj.getPrix_mois_pair()

        print conf['salarie'],'getPrime_pair',conf['salarie'].getPrime_pair()
        print conf['prime'],'getQuantite_entre_mois_pair',conf['prime'].getQuantite_entre_mois_pair()
        
        print 'compute_prime_by_salarie',str(conf['journal'].compute_prime_by_salarie())
        
        
        print "--------------- SUPPRESSION ----------------------"
        
        self.portal.baty_tool.mvt_journal_heure_ligne(journalHeurePrime,create=0)

        list=conf['affaire'].getMouvementByFamille()
        obj=list[0][1]
        
        print obj,'getQuantite_mois_pair',obj.getQuantite_mois_pair()
        print obj,'getPrix_mois_pair',obj.getPrix_mois_pair()
        print conf['salarie'],'getPrime_pair',conf['salarie'].getPrime_pair()
        print conf['prime'],'getQuantite_entre_mois_pair',conf['prime'].getQuantite_entre_mois_pair()

        print journalHeurePrime,'getPrix',journalHeurePrime.getPrix()
        

       


    def test_clorure(self):
        """ test de la cloture du journal
        1 - on cree les ligne du journal
        2 - on les mouvemente
        3 - on cloture le journal : L'operateur doit saisir le salaire paye et le salaire net
        4 - a la cloture , un nouveau journal est creer
        """
        conf=self.create_SetUp()
        self.login('PloneManager')


        
        journalHeure=conf['journal']
        journalHeure._setObject('heure1',BatyJournalHeureLigne('heure1'))
        journalHeureLigne=journalHeure['heure1']

        kw={'salarie':conf['salarie'].UID(),
            'affaire':conf['affaire'].UID(),
            'quantite':10,
            'tache':conf['tache'].UID(),
            }

        ### quantite 10
        
        journalHeureLigne.update(**kw)
        journalHeure._setObject('prime1',BatyJournalHeureLigne('prime1'))
        journalHeurePrime=journalHeure['prime1']

        kw={'salarie':conf['salarie'].UID(),
            'affaire':conf['affaire'].UID(),
            'quantite':10,
            'tache':conf['prime'].UID(),
            }

        
        
        journalHeurePrime.update(**kw)

        

        
        print "-------------- MOUVEMENT ---------------"
        self.portal.baty_tool.mvt_journal_heure_ligne(journalHeureLigne,create=1)
        self.portal.baty_tool.mvt_journal_heure_ligne(journalHeurePrime,create=1)

        print "-------------- CLOTURE -----------------"


        ### cloture de journal
        self.portal.baty_tool.clt_journal_heure(journalHeure,{conf['salarie'].UID():{'salaire_global':1500,'salaire_paye':1000}})
        
        ### verification de ce qui c'est passe
        print "------------------ Apres cloture : niveau affaire --------------------"
        list=conf['affaire'].getMouvementByFamille()
        for (x,obj,z) in conf['affaire'].getMouvementByFamille():
            print obj,'getQuantite_mois_pair',obj.getQuantite_mois_pair()
            print obj,'getPrix_mois_pair',obj.getPrix_mois_pair()
            print obj,'getQuantite_exercice',obj.getQuantite_exercice()
            print obj,'getPrix_exercice',obj.getPrix_exercice()

            
        #### verification au niveau de journal
        print "------------------ Apres cloture : niveau journal --------------------"
        print conf['tache'],'getQuantite_entre_mois_pair',conf['tache'].getQuantite_entre_mois_pair()
        print conf['tache'],'getQuantite_entre_exercice',conf['tache'].getQuantite_entre_exercice()
        print conf['salarie'],'getSalaire_pair',conf['salarie'].getSalaire_pair()
        print conf['salarie'],'getSalaire_exercice',conf['salarie'].getSalaire_exercice()
        print conf['salarie'],'getPrime_pair',conf['salarie'].getPrime_pair()
        print conf['salarie'],'getPrime_exercice',conf['salarie'].getPrime_exercice()

        ##### verification des frais generaux
        entreprise=self.getEntreprise()
        affaire_frais_generaux=entreprise.getFirstObjectForType(type='BatyFraisGeneraux')
        for (x,obj,z) in affaire_frais_generaux.getMouvementByFamille():
            print obj,'getQuantite_mois_pair',obj.getQuantite_mois_pair()
            print obj,'getPrix_mois_pair',obj.getPrix_mois_pair()
            print obj,'getQuantite_exercice',obj.getQuantite_exercice()
            print obj,'getPrix_exercice',obj.getPrix_exercice()


        #self.portal.baty_tool.clt_journal_heure_ligne(journalHeureLigne,info_salaire=[)

    
    def test_clorure_periode(self):
        """ test de la cloture de periode : workflow de la cloture des heures
        ce test permet de voir si on creer effectivment une nouvelle periode et qu l'on cloture la permiere periode
        La regle est que on ne peut pas cloturer la deuxiemme periode
        
        """
        entreprise=self.getEntreprise()
        list_periode=entreprise.getPeriodes()
        print str([ x.get_periode_type() for x in entreprise.getPeriodes() ])
        entreprise.cloturePeriode(list_periode[0].get_periode_type() )
        print str([ str(x) for x in entreprise.getPeriodeEnCours() ])
        
        
        
if __name__ == '__main__':
    framework()
else:
    # While framework.py provides its own test_suite()
    # method the testrunner utility does not.
    def test_suite():
        from unittest import TestSuite, makeSuite
        suite = TestSuite()
        suite.addTest(makeSuite(TestSomeProduct))
        return suite
