#
# Skeleton PloneTestCase
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
#from Products.CMFPlone.tests import PloneTestCase
from Products.ArchBaty.tests import BatyTestCase
from Products.ArchBaty.baty_types.BatyArticle import BatyArticle
from Products.ArchBaty.baty_types.BatyAffaire import BatyAffaire
from Products.ArchBaty.baty_types.BatyJournal import BatyBaseJournal, BatyJournal, BatyJournalLigne
from DateTime import DateTime
from Acquisition import aq_self


class TestWorkflowJournal( BatyTestCase.BatyTestCase):

    def create_SetUp(self):
        t=self.top()
        self.login('PloneManager')
        get_transaction().begin()
        ## creation article ###
        entreprise=self.getEntreprise()
        
        base_article=entreprise.getDestination('BatyArticle')
        base_article.invokeFactory(id='article1',type_name='BatyArticle')
        base_article.invokeFactory(id='article2',type_name='BatyArticle')

        article1=base_article.article1
        article2=base_article.article2

        kw={'famille':entreprise.getFirstObjectForType('BatyFamille').UID(),'unite':'litre','prix':1.0,'stock':1,'quantite':54.0}
        base_article.article1.update(**kw)
        base_article.article2.update(**kw)

        

        
        ## creation client ##
        entreprise.getDestination('BatyClient').invokeFactory(id='client1',type_name='BatyClient')
        ## creation affaire ##
        entreprise.getDestination('BatyAffaire').invokeFactory(id='affaire1',type_name='BatyAffaire')
        affaire1=entreprise.getDestination('BatyAffaire').affaire1

        
        ## creation journal ##
        #self.createMemberarea('PloneManager')
        #membership = self.portal.portal_membership
        #folder=membership.getHomeFolder('PloneManager')
        folder=self.getEntreprise().getDestination('BatyJournal')
        
        
        folder._setObject('journal',BatyJournal('journal'))
        journal=folder.journal
        pds=entreprise.getPeriodes()

        # on a une display list
        
        kw={'periode':str(pds[0]),'entreprise':entreprise.UID(),'date_de_saisie':DateTime()}
        journal.update(**kw)

        return  {
            'article1':article1,
            'article2':article2,
            'affaire':affaire1,
            'journal':journal
            }

        
        
        

    

    def testGoodSetup(self):
        #user=self.getManagerUser()
        #newSecurityManager(None,user)*
        conf=self.create_SetUp()
        self.login('PloneManager')
        
        result=self.portal.portal_catalog.search({'portal_type':('BatyJournal',)})
        #print str(result)
        self.failUnless(len(result))
        

    def test_workflow(self):
        conf=self.create_SetUp()
        self.login('PloneManager')
        
        result=self.portal.portal_catalog.search({'portal_type':('BatyJournal',)})
        #print str(result)
        self.failUnless(len(result))


        ## on cree les ligne dans le journal

        
        journal=conf['journal']
        journal.invokeFactory(id="matiere1", type_name='BatyJournalLigne')
        kw={
            'affaire':conf['affaire'].UID(),
            'article':conf['article1'].UID(),
            'stock':1,
            'quantite':10,
            'prix_unitaire':1
            }

        journal['matiere1'].update(**kw)

        print journal['matiere1'].introspect()
        print conf['article1']
        print conf['article1'].introspect()
        print conf['article1'],'coef value',conf['article1'].getCoefficientValue()

        journal.baty_tool.cloture_journal(journal)

        print conf['article1'].introspect()
        for item in conf['affaire'].getMouvementByFamille():
            print item[1].introspect()

    


#     def test_workflow(self):
#         print self.portal.portal_workflow.getChainFor(self.journal)
#         self.login('PloneManager')
#         print self.portal.test_baty.portal_workflow.getActionsFor(self.journal)
#         self.portal.test_baty.portal_workflow.doActionFor(self.journal,'mouvementer')

if __name__ == '__main__':
    framework()
else:
    # While framework.py provides its own test_suite()
    # method the testrunner utility does not.
    def test_suite():
        from unittest import TestSuite, makeSuite
        suite = TestSuite()
        suite.addTest(makeSuite(TestSomeProduct))
        return suite
