from Products.Archetypes.public import Schema,registerType
from Products.Archetypes.config import TOOL_NAME
from Products.CMFCore.utils import getToolByName
from Products.Archetypes.debug import log
from BatyObject import BatyObject
from Products.ArchBaty.BatyException import BatyException
from Products.ArchBaty.properties import BatyFields

from Products.ArchBaty.BatyUtils import addObject
#from Products.ArchBaty.interfaces.baty_mouvement import IBatyMouvement




def addBatyArticleFraisStockage(self,id=None,**kwargs):
    addObject(self,BatyArticleFraisStockage,id,**kwargs)
    
    
    
    
    

 
def addBatyArticleFraisGeneraux(self,id=None,**kwargs):
    #print "id --------",id
    addObject(self,BatyArticleFraisGeneraux,id,**kwargs)


def addBatyArticleCredit(self,id=None,**kwargs):
    addObject(self,BatyArticleCredit,id,**kwargs)


class BatyBaseElement(BatyObject,):
    
    schema= Schema((
        BatyFields.hidden_title(),
        BatyFields.code_num(),
        BatyFields.code_alpha(),
        BatyFields.description(),
        BatyFields.code_exploitation(),
        BatyFields.famille(),
        BatyFields.unite(),
        
        
        ))

    def getCoefficient(self):
        """ return l'uid du coefficient """
        obj_famille=self.getObjectFromAttr('famille')
        if obj_famille is not None:
            return obj_famille.getCoefficient()
        else:
            return 0.0

    def getCoefficientObject(self):
        """ return l'objet coefficient """
        obj_famille=self.getObjectFromAttr('famille')
        if obj_famille is not None:
            return obj_famille.getObjectFromAttr('coefficient')
        else:
            return None
        
    def getCoefficientValue(self):
        """ return la valeur coefficient """
        obj=self.getCoefficientObject()
        if obj is not None:
            return obj.getCoefficient()
        


    def get_default_unite(self):
        log("appel de default unite") 
        return 'kil'

    def get_default_famille(self):
        
        return 'mat'


    def getArticleFraisObject(self):
        """ renvoie l'article des frais generaux"""
        return self.getCoefficientObject().getArticleFraisObject()

    def getArticleCreditObject(self):
        """ renvoie l'article credit """
        return self.getCoefficientObject().getArticleCreditObject()
    

    def famille_value(self):
        """ retourne la famille """
        archetype_tool = getToolByName(self, TOOL_NAME)
        try:
            return archetype_tool.lookupObject(uid=getattr(self,'famille')).id
        except:
            return

    def Title(self):
        """ retourne le titre """
        if hasattr(self,'code_num') and hasattr(self,'famille'):
            try:
                #return str(self.getCode_num())+'-'+self.famille_value()+ '-'+ self.portal_type[4:]
		return str(self.getCode_num())+'-'+self.getCode_alpha()+ '-'+ self.portal_type[4:]
            
            except:
	        return self.portal_type[4:]+'_'+self.id 
        else:
            return self.id
            
#         id_famille=self.archetype_tool.getObject(ref_famille).getId()
#         return 
#         return getattr(self,'title',self.id)


    

class BatyMouvementEntre(BatyObject,):
    schema= Schema((
        BatyFields.quantite_entre_mois_pair(),
        BatyFields.quantite_entre_mois_impair(),
        BatyFields.quantite_entre_exercice(),
        ))

    def clt_month(self,periodeObject):
        
        periode_id=periodeObject.get_periode_type()

                ## on sauve les resultats tabeleau des douze mois avec i = entre et j sorti
        quantite_mois=getattr(self,'quantite_mois',
                              [0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0])

        #print self.introspect()
        quantite_mois[periodeObject.month - 1]=getattr(self,'quantite_entre_mois_%s' % (periode_id,),0)

        setattr(self,'quantite_mois',quantite_mois)

        ## on met tous le monde a zero
        setattr(self,'quantite_entre_mois_%s' % (periode_id,),0.0)


    def clt_year(self,year):
            """ cloture l'annee """
            return

    
class BatyMouvementSorti(BatyObject,):
    schema = Schema((
        BatyFields.quantite_sorti_mois_pair(),
        BatyFields.quantite_sorti_mois_impair(),
        BatyFields.quantite_sorti_exercice(),
        ))



    
class BatyElement(BatyObject,):
    """ base commune des familles baty article, tache, produit et materiel """

    schema= Schema((
#        BatyFields.coefficient(),
        BatyFields.prix(),
#        BatyFields.code_comptable(),
        
        ))

    def setPrix(self,value):
        """ mis a jour du prix, prix moyen ponderer et prix de vente """
        
        value=float(value)
        if hasattr(self,'prix') and getattr(self,'prix') != value or not hasattr(self,'prix'):
            ## si affectation d'une nouvelle valeur ou si on n'a jamais fixer de prix
            log("setprix")
            setattr(self,'prix',value)
            setattr(self,'prix_moyen_ponderer',value)
             
            setattr(self,'prix_vente',(1.0+self.coefficient_value()/100.0)*value)
        
    
    def getCoefficient(self):
        """ retourne l'uid du coefficient"""
        famille=self.getFamille()
        
        
        

        
    def coefficient_value(self):
        """ return le coefficient """
        archetype_tool = getToolByName(self, TOOL_NAME)
        try:
            return float(archetype_tool.lookupObject(uid=getattr(self,'coefficient')).getCoefficient())
        except:
            return 0.0

    


        
class BatyStockable(BatyObject):        
    """ base commune pour les object grer en stocks """
    schema= Schema((
                BatyFields.quantite(),
                BatyFields.quantite_theorique(),
                BatyFields.temps_moyen_appro(),
                BatyFields.seuil_stock(),
                BatyFields.prix_moyen_ponderer(),
                BatyFields.dernier_prix_achat(),
                BatyFields.prix_vente(),

                ))


    def setQuantite(self,value):
        """ ajuste la quantite """
        if value:
            if not hasattr(self,'quantite_theorique') or not getattr(self,'quantite_theorique'):
                # la quantite theorique = quantite
                setattr(self,'quantite',float(value))
                setattr(self,'quantite_theorique',float(value))
            else:
                # on ajuste la quantite reel
                st=getattr(self,'quantite_theorique',0)
                sr_avant=getattr(self,'quantite',0)
                diff=float(sr_avant)-float(st)
                # le nouveau stock theoriqe est la nouvelle valeur du stock
                # moins l'ancienne difference entre le stock reel et stock theorique
                st_new=float(value)-diff
                setattr(self,'quantite_theorique',float(st_new))
                setattr(self,'quantite',float(value))


    def maj_stock_theorique(self,quantite):
        """ mis a jour de la quantit theorique """
        st_old=getattr(self,'quantite_theorique',0)
        st_new=st_old-quantite
        #log(" maj_stock_theorique %s %s" % (str(quantite),str(st_new)))
        if st_new>=0 :
            setattr(self,'quantite_theorique',float(st_new))
        else:
            raise BatyException('Stock can not be negative')
        
    def set_new_stock_theorique(self,quantite):
        #log("mise a jour du stock",quantite)
        if float(quantite) >= 0:

            setattr(self,'quantite_theorique',float(quantite))
        else:
            raise BatyException('Stock can not be negative')

def addBatyArticle(self,id,*args,**kw):
    o=BatyArticle(id)
    self._setObject(id,o)
    return id
    

class BatyArticle(BatyObject,BatyBaseElement,BatyElement,BatyStockable,BatyMouvementEntre,BatyMouvementSorti):
    portal_type = meta_type = 'BatyArticle' 
    archetype_name = 'BatyArticle'   #this name appears in the 'add' box 
    schema= BatyObject.schema + BatyBaseElement.schema + BatyElement.schema + Schema((BatyFields.en_stock(),)) + BatyStockable.schema + BatyMouvementEntre.schema + BatyMouvementSorti.schema

    #Methods (probleme avec archetype)
    #__implements__ = IBatyMouvement
    
        
    def getCode_exploitation(self):
        if not getattr(self,'code_exploitation',0):
            setattr(self,'code_exploitation','ce1')
        return self.baty_tool['compte_exploitation'].getProperty(getattr(self,'code_exploitation'))

    def prix_value(self):
        """ retourne la famille """
        return self.getPrix()

    def isEn_stock(self):
        """ retourne vraie si l'article est gerer en stock, faux sinon """
        return int(getattr(self,'stock',0))

    
    def getFamille(self):
        if hasattr(self,'famille') and getattr(self,'famille'):
            return getattr(self,'famille')
        else:
            return self.get_default_famille()
        
    def getUnite(self):
        if hasattr(self,'unite') and getattr(self,'unite'):
            return getattr(self,'unite')
        else:
            return self.get_default_unite()

    


    def getCode_num(self):
         if hasattr(self,'code_num') and getattr(self,'code_num'):
             return getattr(self,'code_num')
         else:
             return self.getDefaultCodeNum()

    
    def clt_month(self, periodeObject):
        
        periode_id=periodeObject.get_periode_type()

        
        ## on sauve les resultats tabeleau des douze mois avec i = entre et j sorti
        quantite_mois=getattr(self,'quantite_mois',
                              [(0,0),(0,0),(0,0),(0,0),(0,0),(0,0),(0,0),(0,0),(0,0),(0,0),(0,0),(0,0)])


        
        quantite_mois[periodeObject.month - 1]=(getattr(self,'quantite_entre_mois_%s' % (periode_id,),0),
                                                getattr(self,'quantite_sorti_mois_%s' % (periode_id,),0))
        setattr(self,'quantite_mois',quantite_mois)
        

        ## on met tous le monde a zero
        setattr(self,'quantite_entre_mois_%s' % (periode_id,),0.0)
        setattr(self,'quantite_sorti_mois_%s' % (periode_id,),0.0)

    def clt_year(self,year):
        """ cloture l'annee """
        return


    
        
registerType(BatyArticle)# end class BatyArticle

class BatyTache(BatyBaseElement,BatyElement,BatyMouvementEntre):
    schema=BatyObject.schema + BatyBaseElement.schema  +BatyMouvementEntre.schema+ Schema((BatyFields.prix_tache()))
    #Schema((       # BatyFields.code_comptable(),        ))
    

    portal_type = meta_type = 'BatyTache'
    archetype_name = 'BatyTache'

    #__implements__ = IBatyMouvement
        
    def getCode_exploitation(self):
        if not getattr(self,'code_exploitation',0):
            setattr(self,'code_exploitation','ce1')
        return self.baty_tool['compte_exploitation'].getProperty(getattr(self,'code_exploitation'))


    def get_default_unite(self):
        log("appel de default unite") 
        return 'heu'

    def get_default_famille(self):
        return 'mdo'

    def isPrime(self):
        return 0
    
    
    

registerType(BatyTache)

class BatyPrime(BatyTache):
    schema=BatyTache.schema + Schema((BatyFields.prix()))

    portal_type = meta_type = 'BatyPrime'
    archetype_name = 'BatyPrime'
    
    def getCode_exploitation(self):
        if not getattr(self,'code_exploitation',0):
            setattr(self,'code_exploitation','ce1')
        return self.baty_tool['compte_exploitation'].getProperty(getattr(self,'code_exploitation'))

    def get_default_unite(self):
        return 'heu'

    def get_default_famille(self):
        return 'mdo'

    def isPrime(self):
        return 1;
    
registerType(BatyPrime)




class BatyArticleCredit(BatyBaseElement,BatyMouvementEntre):
    schema=BatyObject.schema + BatyBaseElement.schema + BatyMouvementEntre.schema

    portal_type = meta_type = 'BatyArticleCredit' 
    archetype_name = 'BatyArticleCredit'   #this name appears in the 'add' box 

    def __init__(self,id):
        self.id=id
        self.famille='crd'
        self.description='Article cr\xE9dit, cr\xE9\xE9 automatiquement par baty , ne pas detruire'
        self.code_alpha='Article Credit'
        


    def getCode_exploitation(self):
        if not getattr(self,'code_exploitation',0):
            setattr(self,'code_exploitation','ce3')
        return self.baty_tool['compte_exploitation'].getProperty(getattr(self,'code_exploitation'))
    



registerType(BatyArticleCredit)

    
class BatyArticleFraisGeneraux(BatyBaseElement,BatyMouvementEntre):
    schema=BatyObject.schema + BatyBaseElement.schema + BatyMouvementEntre.schema +  Schema((
        BatyFields.coefficient(),
               
        )) 
    
    portal_type = meta_type = 'BatyArticleFraisGeneraux' 
    archetype_name = 'BatyArticleFraisGeneraux'   #this name appears in the 'add' box 

    
    def __init__(self,id):
        self.id=id
        self.famille='frg'
        self.description='Frais g\xE9n\xE9raux'
        self.code_alpha='Frais g\xE9n\xE9raux'

    

    def getCode_exploitation(self):
        if not getattr(self,'code_exploitation',0):
            setattr(self,'code_exploitation','ce2')
        return self.baty_tool['compte_exploitation'].getProperty(getattr(self,'code_exploitation'))

    
registerType(BatyArticleFraisGeneraux)

class BatyArticleFraisStockage(BatyArticleFraisGeneraux):
    schema=BatyArticleFraisGeneraux.schema

    portal_type = meta_type = 'BatyArticleFraisStockage' 
    archetype_name = 'BatyArticleFraisStockage'   #this name appears in the 'add' box 


    def __init__(self,id):
        self.id=id
        self.famille='frg'
        self.description='Frais de stockage'
        self.code_alpha='Frais de stockage'

    def getCode_exploitation(self):
        if not getattr(self,'code_exploitation',0):
            setattr(self,'code_exploitation','ce2')
        return self.baty_tool['compte_exploitation'].getProperty(getattr(self,'code_exploitation'))

registerType(BatyArticleFraisStockage)

class BatyMouvement(BatyObject):
    """ represente un mouvement de quantite sur une affaire d'un article
    """

    portal_type = meta_type = 'BatyMouvement' 
    archetype_name = 'BatyMouvement'   #this name appears in the 'add' box 

    #__implements__ = IBatyMouvement
    
    schema=BatyObject.schema + Schema((BatyFields.ref_affaire(),
                                       BatyFields.ref_article(),
                                      
                                       BatyFields.field_mouvement('prix_mois_impair'),
                                       BatyFields.field_mouvement('prix_mois_pair'),
                                       BatyFields.field_mouvement('quantite_mois_impair'),
                                       BatyFields.field_mouvement('quantite_mois_pair'),
                                       BatyFields.field_mouvement('quantite_exercice'),
                                       BatyFields.field_mouvement('prix_exercice'),

                                       BatyFields.prix_prevu(),
                                       BatyFields.quantite_prevu(),


                                       ))


    def clt_month(self,periodeObject):
        periode_id=periodeObject.get_periode_type()
        
        
        ## on sauve les resultats tabeleau des douze mois avec i = entre et j sorti
        quantite_mois=getattr(self,'quantite_mois',
                              [0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0])
        prix_mois=getattr(self,'prix_mois',
                          [0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0])
        
        
        quantite_mois[periodeObject.month - 1]=getattr(self,'quantite__mois_%s' % (periode_id,),0)
        
        prix_mois[periodeObject.month - 1]=getattr(self,'prix_mois_%s' % (periode_id,),0)

        setattr(self,'quantite_mois',quantite_mois)
        setattr(self,'prix_mois',prix_mois)
        ## on met tous le monde a zero
        setattr(self,'quantite_mois_%s' % (periode_id,),0.0)
        setattr(self,'prix_mois_%s' % (periode_id,),0.0)




    def clt_year(self,year):
        """ cloture l'annee """
        return


registerType(BatyMouvement)
